/*
Company :		ZEFYR Technologies
File :			errorCodes.h
Author :		Matthieu Perreira Da Silva 
Fisrt release :	15/04/2003

Description : list of all error codes available

Features : none		
    
Functions : none

Function prototypes : none

Necessary package : none

Comments :none

*/

#ifndef __ZEFYR_ERROR_CODES_H
#define __ZEFYR_ERROR_CODES_H

// ******** warnings ********  (see description in "dpBio.h" file)
#define WARNING_OFFSET			2
#define ZEF_NO_MATCH			WARNING_OFFSET
#define	ZEF_TOO_MANY_MINUTIAE	WARNING_OFFSET+1
#define ZEF_CORE_CLOSE_TO_BORDER	WARNING_OFFSET+2

// ********  common errors ******** (see description in "dpBio.h" file)
#define ZEF_OK						1
#define ZEF_NULL					(void*)0;
#define	ZEF_NULL_POINTER			-1
#define ZEF_BUFFER_TO_SMALL			-2
#define ZEF_OUT_OF_MEMORY			-3
#define	ZEF_MATHS_ERROR				-4
#define	ZEF_CHECKSUM_FAILED			-5
#define	ZEF_BAD_VERSION				-6
#define ZEF_BAD_SECU_THRESHOLD		-7
#define	ZEF_BAD_MAX_SEARCH			-8
#define	ZEF_ENGINE_NOT_INITIALIZED	-9
#define	ZEF_BAD_SIZE				-10
#define ZEF_NOT_BLOC_MULTIPLE		-11
#define	ZEF_BAD_SPEED_PARAM			-12
#define ZEF_STOPPED					-13

// ******** file errors ******** 
#define	FILE_ERROR_OFFSET		-256

/** Could not open a file (does not exist or other problem) */
#define ZEF_FILE_OPEN			FILE_ERROR_OFFSET

/** Could not read file (end of file reached, not read permission, etc.) */
#define ZEF_FILE_READ			FILE_ERROR_OFFSET-1

/** Could not write to file (end of file reached, not write permission, etc.) */
#define ZEF_FILE_WRITE			FILE_ERROR_OFFSET-2

/** Problme while seeking in file (end of file reached or other problem) */
#define ZEF_FILE_SEEK			FILE_ERROR_OFFSET-3

// ******** BMP file errors ******** 
#define	BMP_ERROR_OFFSET		FILE_ERROR_OFFSET-256

/** The image we are trying to read is not a BMP file. It does not have the 'BM' header*/
#define ZEF_NOT_BMP				BMP_ERROR_OFFSET-1

/** The image we are tring to read is a BMP, but its not a 8 bit uncompressed grayscale image*/
#define ZEF_BMP_BAD_FORMAT		BMP_ERROR_OFFSET-2


#endif //__ZEFYR_ERROR_CODES_H
