/*
Company :		ZEFYR Technologies
File :			exported.h
Author :		Matthieu Perreira Da Silva 
Fisrt release :	09/05/2003

Description : SDK exported functions

Features : external interface functions		
    
Functions : 

	dpInit :	initialize everything
	dpUnInit :	free everything

Necessary package : 

	zMaths.h
	customTypes.h
	errorCodes.h
	staticParameters.h
	dynamicParameters.h
	enhancements.h

Comments : none

*/

#ifndef __ZEFYR_INIT_H
#define __ZEFYR_INIT_H

#include "dynamicParameters.h"

#ifdef __cplusplus
extern "C" {
#endif

// see the description of these functions in "dpBio.h" file
INT32	WINAPI		dpInit( void );
INT32	WINAPI		dpUnInit( void );
char*	WINAPI		dpGetEngineVersion( void );
INT32	WINAPI		dpSetSpeed( UINT32 p_type, INT32 p_speed );

#ifdef __cplusplus
}
#endif

#endif // __ZEFYR_INIT_H
