/*
Company :		ZEFYR Technologies
File :			fxFilters.h
Author :		Matthieu Perreira Da Silva 
Fisrt release :	09/05/2003

Description : fixed point filters like Gabor

Features : fixed point !!!	
    
Functions : 
 
	generateGaborFFT : generates a gabor filter in the frequency domain
	freqConvolution : double convolution in frequancy domain (used with real filters)

Necessary package : 

	customTypes.h
	staticParameters.h
	errorCodes.h
	zMaths.h
	limits.h

Comments : none

*/

#ifndef __ZEFYR_FX_FILTERS_H
#define __ZEFYR_FX_FILTERS_H

#ifdef ZEF_FIXED_POINT

#include "customTypes.h"

#ifdef __cplusplus
extern "C" {
#endif


// Fixed point versions of some functions defined in "filters.h"
// See "filters.h" for detailed descriptions
INT32 generateGaborFFT( FIXED16 *p_filter, FIXED32 p_size, FIXED32 p_freq, INT32 p_angle );
INT32 freqConvolution( FIXED16 *p_src, FIXED16 *p_dst, FIXED16 *p_filter );
INT32 sobelGradient( UINT8 *p_src, INT16 *p_gradient, UINT32 p_width, UINT32 p_height );

#ifdef __cplusplus
}
#endif

#endif // ZEF_FIXED_POINT

#endif // __ZEFYR_FILTERS_H 
