/*
Company :		ZEFYR Technologies
File :			fxLinAlgebra.h
Author :		Matthieu Perreira Da Silva 
Fisrt release :	04/07/2003

Description : linear system resolution (fixed point)

Features : finds the solutyions of a linear sysem
    
Functions : 

	luDecompose : transform a matrix into its LU decomposition (used to solve a linear system)
	luBackSubstitute : resolve a system using its LU decomposition

Necessary package : 

	customTypes.h
	errorCodes.h
	staticParameters.h
	dynamicParameters.h
	zMaths.h

Comments : none

*/

#ifndef __ZEFYR_FX_LIN_ALGEBRA_H
#define __ZEFYR_FX_LIN_ALGEBRA_H


#ifdef ZEF_FIXED_POINT

#include "customTypes.h"

#ifdef __cplusplus
extern "C" {
#endif

// Fixed point version of the functions defined in "linAlgebra.h"
// see "linAlgebra.h" for function description
INT32 luDecompose(INT32 **p_matrix, INT32 p_size, INT32 *p_index, INT32 *p_evenOdd);
INT32 luBackSubstitute(INT32 **p_matrix, INT32 p_size, INT32 *p_index, INT32 p_rightSide[]);

#ifdef __cplusplus
}
#endif


#endif //ZEF_FIXED_POINT

#endif //__ZEFYR_LIN_ALGEBRA_H
