/*
Company :		ZEFYR Technologies
File :			quicksort.h
Author :		Matthieu Perreira Da Silva 
Fisrt release :	09/05/2003

Description : sorting algorithms

Features : a fast sorting algorithm 
    
Functions : 

	sortUINT32 : main sorting routine
	splitUINT32 : split the array int who arrays, one with values > pivot the othe with values < pivot

Necessary package : 

	none

Comments : none

*/

#ifndef __ZEF_QUICKSORT
#define __ZEF_QUICKSORT

#ifdef __cplusplus
extern "C" {
#endif

#include "customTypes.h"


/** Sort an array using the quicksort algorithm
 *  This is a special sorting algorithm : the input array + an index array are modified
 *  The index array allows to retrieved the sorted values in tanather array "linked" to the source array.
 * 
 *	@param			p_tab			Array to be sorted (will not be modified)
 *	@param			p_index			Array containing the indexes  of each p_tab entry.
 *									as input contains [0,1,2,3,...,n]
 *									as output contains the sorted index values (sorted according to p_tab content)
 *	@param			p_borneInf		Index of first p_tab element to be sorted
 *	@param			p_borneSup		Index of last p_tab element to be sorted						
*/
void sortUINT32( UINT32 *p_tab, UINT32 *p_index, INT32 p_borneInf, INT32 p_borneSup );


/**	Splits an array into two parts
 * 
 *	@param			p_tab		Array to be sorted (will not be modified)
 *	@param			p_index		Array of indexes (will be modified)
 *	@param			p_taille	Size of p_tab (and p_index)
 * 
 *	@return			Position of the splitting point			
*/
INT32 splitUINT32( UINT32 *p_tab, UINT32 *p_index,  INT32 p_taille );

#ifdef __cplusplus
}
#endif

#endif /*__ZEF_QUICKSORT */
