#!/bin/bash

FVC_Enroll="/cygdrive/f/DigiPass BioEngine/projects/FVC_Enroll/Release/enroll_P048.exe"
FVC_Match="/cygdrive/f/DigiPass BioEngine/projects/FVC_Match/Release/match_P048.exe"
ListA_MFA="F:\DigiPass BioEngine\projects\Script Test FVC\index_a.MFA"
ListA_MFR="F:\DigiPass BioEngine\projects\Script Test FVC\index_a.MFR"
ListB_MFA="F:\DigiPass BioEngine\projects\Script Test FVC\index_b.MFA"
ListB_MFR="F:\DigiPass BioEngine\projects\Script Test FVC\index_b.MFR"
EnrollFile=enroll.txt
FarFile=far.txt
FrrFile=frr.txt

if  test $# -ne 2; then
   echo "Usage -a|-b ConfigFile.cfg"
   exit
fi

if [ "$1" == "-a" ]; then
   ListFAR=$ListA_MFA
   ListFRR=$ListA_MFR
else
   ListFAR=$ListB_MFA
   ListFRR=$ListB_MFR
fi
Config=$2

((nbTempl=`ls *.tif | wc -l`))

echo "Generate $nbTempl templates :"
sleep 2

ls *.tif > tempLst

i=0
while read file
do
  templ=${file/.tif/.bin}
  echo "$file ($i/$nbTempl)"
  ((i = $i + 1))
  "$FVC_Enroll" $file $templ $Config $EnrollFile
  if [ $? -ne 0 ]; then
     echo error during extraction
  fi
done <tempLst

rm tempLst

((nbTstFAR=`wc -l <"$ListFAR"`))
echo "Processing $nbTstFAR FAR test :"
sleep 2
i=0
while read file1 file2
do
  templ2=${file2/.tif/.bin}
  echo "$file1 $templ2 ($i/$nbTstFAR)"
  ((i = $i + 1))
  "$FVC_Match" $file1 $templ2 $Config $FarFile
  if [ $? -ne 0 ]; then
     echo error during matching
  fi
done <"$ListFAR"



((nbTstFRR=`wc -l <"$ListFRR"`))
echo "Processing $nbTstFRR FRR test :"
sleep 2
i=0
while read file1 file2
do
  templ2=${file2/.tif/.bin}
  echo "$file1 $templ2 ($i/$nbTstFRR)"
  ((i = $i + 1))
  "$FVC_Match" $file1 $templ2 $Config $FrrFile
  if [ $? -ne 0 ]; then
     echo error during matching
  fi
done <"$ListFRR"

echo Test Termin
