/*
Company :		ZEFYR Technologies
File :			main.c
Author :		Matthieu Perreira Da Silva 
Fisrt release :	15/04/2003

Description : main testing file

Features : none	
    
Functions : 

	main : main function...

Function prototypes : 

	void main( int argc, char *argv[] );

Necessary package : none

Comments :none

*/

#include <stdlib.h>
#include <stdio.h>
#include <time.h>

#include "errorCodes.h"
#include "BMPfiles.h"
#include "enrollExport.h"
#include "matchExport.h"
#include "exported.h"
#include "compatibility.h"
#include "zMaths.h"

int loadTemplateFile( char *p_filename, unsigned char *p_buffer )
{
	FILE			*file;
	unsigned int	size;

	file = fopen(p_filename,"rb" );
	fread(&size,sizeof(unsigned int),1,file);
	fseek(file,0,SEEK_SET);
	fread(p_buffer,size,1,file);

	fclose(file);

	return 1;
}

void main( int argc, char *argv[] )
{ 
	int				error;
	unsigned char	*buffer,*preview;
	unsigned char	*myTemplate1,*myTemplate2;
	unsigned char	*templateOldFormat;
	int				size,i;
	int				width, height;
	clock_t			t1,t2;
	unsigned int	score/*,flags*/;
	FILE			*file;

	if( argc != 3 )
	{
		//printf("usage : test.exe filename1.bmp filename2.bmp");
		//return;
		argv[1] = "G:\\_CVS_\\DpBioEngine\\projects\\Test\\Test1.bmp";
		argv[2] = "G:\\_CVS_\\DpBioEngine\\projects\\Test\\Test2.bmp";
	}

	printf("dpBioEngine Test v%s\n\n",dpGetEngineVersion()); 

	dpInit();
	
	dpSetSecurity(0);

	dpSetSpeed(0, 0);

	size = dpGetMaxTemplateSize();
	myTemplate1 = (unsigned char*)MALLOC(size);
	myTemplate2 = (unsigned char*)MALLOC(size);

	templateOldFormat = (unsigned char*)MALLOC(sizeof(GabaritV2));

	// 1st template
	error = getBmpSize( "G:\\_CVS_\\DpBioEngine\\projects\\Test\\Test1.bmp"/*argv[1]*/, &size );
	if( error < ZEF_OK )
	{
		printf("getBMPsize error\n");
		return;
	}

	buffer = (unsigned char*) MALLOC(size*sizeof(unsigned char));
	preview = (unsigned char*) MALLOC(size*sizeof(unsigned char));

	error = loadBmp( "G:\\_CVS_\\DpBioEngine\\projects\\Test\\Test1.bmp"/*argv[1]*/, buffer, size, &width, &height );
	if( error < ZEF_OK )
	{
		printf("loadBMP error\n");
		return;
	}

	printf("Template 1\n");

	/*t1 = clock();
	dpProcessPreview( buffer, width, height, preview, &flags );
	saveBmp("F:\\DpBioEngine\\projects\\Test\\Preview.bmp",preview,width,height);
	t2 = clock();
	printf("time: %f, flags: %d\n",(t2-t1)/(float)CLOCKS_PER_SEC, flags);*/

	FREE( preview );

	t1 = clock();
	for( i=0; i<1; i++ )
		dpGenerateTemplate( buffer, width, height, myTemplate1 );
	t2 = clock();
	printf("time: %f\n",(t2-t1)/(float)CLOCKS_PER_SEC);

	// 2nd template
	error = getBmpSize( "G:\\_CVS_\\DpBioEngine\\projects\\Test\\Test2.bmp"/*argv[2]*/, &size );
	if( error < ZEF_OK )
	{
		printf("getBMPsize error\n");
		return;
	}

	FREE(buffer);
	buffer = (unsigned char*) MALLOC(size*sizeof(unsigned char));

	error = loadBmp( "G:\\_CVS_\\DpBioEngine\\projects\\Test\\Test2.bmp"/*argv[2]*/, buffer, size, &width, &height );
	if( error < ZEF_OK )
	{
		printf("loadBMP error\n");
		return;
	}

	printf("Template 2\n");
	t1 = clock();
	for( i=0; i<1; i++ )
		dpGenerateTemplate( buffer, width, height, myTemplate2 );
	t2 = clock();
	printf("time: %f\n",(t2-t1)/(float)CLOCKS_PER_SEC);

	//getIndexScore( myTemplate1, myTemplate2, &score ); 
	//printf("index score : %d\n", score );

	printf("Matching\n");
	t1 = clock();

	// comparison
	for( i=0; i<1 ; i++ )
		dpVerifyTemplate( myTemplate1, myTemplate2, &score );
		
	
	t2 = clock();
	printf("time: %f\n",(t2-t1)/(float)(CLOCKS_PER_SEC*1));

	printf("score=%d\n",score);

	// save
	file = fopen("test1.bin","wb");
	fwrite(myTemplate1, *((UINT32*)myTemplate1),1,file);
	fclose(file);
	file = fopen("test2.bin","wb");
	fwrite(myTemplate2, *((UINT32*)myTemplate2),1,file);
	fclose(file);
	
	FREE(templateOldFormat);
	FREE(buffer);
	FREE(myTemplate1);
	FREE(myTemplate2);

	dpUnInit();

	GET_PEAK_MEM;
	GET_ALLOCATED_MEM;

}
