// AuthentPage.cpp : implementation file
//

#include "stdafx.h"
#include "dpBioDemo.h"
#include "AuthentPage.h"
#include "dpBio.h"
#include "errorCodes.h"
#include "DpBioDemoView.h"
#include "myFuncs.h"
#include "HiResCounter.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CDpBioMainView* m_demoView;

/////////////////////////////////////////////////////////////////////////////
// CAuthentPage property page

IMPLEMENT_DYNCREATE(CAuthentPage, CPropertyPage)

CAuthentPage::CAuthentPage() : CPropertyPage(CAuthentPage::IDD)
{
	//{{AFX_DATA_INIT(CAuthentPage)
	m_authentSource = -1;
	//}}AFX_DATA_INIT
}

CAuthentPage::~CAuthentPage()
{
}

void CAuthentPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAuthentPage)
	DDX_CBIndex(pDX, IDC_AUTHENT_SOURCE, m_authentSource);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CAuthentPage, CPropertyPage)
	//{{AFX_MSG_MAP(CAuthentPage)
	ON_BN_CLICKED(IDC_SECU4, OnSecu4)
	ON_BN_CLICKED(IDC_SECU0, OnSecu0)
	ON_BN_CLICKED(IDC_SECU1, OnSecu1)
	ON_BN_CLICKED(IDC_SECU2, OnSecu2)
	ON_BN_CLICKED(IDC_SECU3, OnSecu3)
	ON_BN_CLICKED(IDC_SECU5, OnSecu5)
	ON_BN_CLICKED(IDC_AUTHENT_BUTTON, OnAuthentButton)
	ON_BN_CLICKED(IDC_SECU6, OnSecu6)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAuthentPage message handlers

BOOL CAuthentPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	CComboBox	*box;
	CRect		rect;

	CheckRadioButton(IDC_SECU0,IDC_SECU5,IDC_SECU4 );

	m_authentSource = 0;
	m_demoView = (CDpBioMainView *)GetParent()->GetParent();
	box = (CComboBox *)GetDlgItem(IDC_AUTHENT_SOURCE);
	box->GetClientRect(&rect);
	box->SetWindowPos(NULL,0,0,rect.right,256,SWP_NOOWNERZORDER|SWP_NOMOVE);

	UpdateData(false);
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CAuthentPage::OnSecu0() 
{
	if( dpSetSecurity(0) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 0");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}

void CAuthentPage::OnSecu1() 
{
	if( dpSetSecurity(25) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 10-1");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}

void CAuthentPage::OnSecu2() 
{
	if( dpSetSecurity(50) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 10-2");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}

void CAuthentPage::OnSecu3() 
{
	if( dpSetSecurity(75) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 10-3");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}

void CAuthentPage::OnSecu4() 
{
	if( dpSetSecurity(100) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 10-4");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}

void CAuthentPage::OnSecu5() 
{
	if( dpSetSecurity(125) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 10-5");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}


void CAuthentPage::OnSecu6() 
{
	if( dpSetSecurity(150) >= 1 )
		m_demoView->WriteToInfoCtrl("Security level set to 10-6");
	else
		m_demoView->WriteToInfoCtrl("Security level modification failed");
}


void CAuthentPage::OnAuthentButton() 
{	
	unsigned char	*templBuf;
	int				i,j,size,index,index2,error=0;
	int				nbItems;
	unsigned int	score;
	CString			text,fileName;
	CHiResCounter	timer;
	double			totalTime=0;
	CProgressDlg	progress(this);

	UpdateData(true);
	
	size = dpGetMaxTemplateSize();
	templBuf = new unsigned char[size];

	CFileDialog	*fileDlg;

	switch(m_authentSource)
	{
	case 0: // FILE LOAD
		fileDlg = new CFileDialog(true,".bin","Please select template file to load",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
			"Template Files (*.bin)|*.bin||",this);
		error = fileDlg->DoModal();
		if( error == IDOK )
		{
			// load file
			fileName = fileDlg->GetPathName();
			error =loadTemplateFile( fileName , templBuf );
		}
		else
			error=0;
		delete fileDlg;
		break;
	case 1: // IMG_LOAD
		fileDlg = new CFileDialog(true,".bmp","Please select template file to load",OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,
			"Image Files (*.bmp)|*.bmp||",this);
		error = fileDlg->DoModal();
		if( error == IDOK )
		{
			// load file
			fileName = fileDlg->GetPathName();
			error =enrollFromFile( fileName , templBuf );
		}
		else
			error=0;
		delete fileDlg;
		break;
	default:
		return;
		break;
	}

	if( error >= 1 )
	{
		for( i=0; i<m_demoView->m_nbTemplates; i++ )
			m_demoView->m_scores[i] = -1;
		POSITION	pos;
		nbItems = m_demoView->m_listCtrl.GetSelectedCount();
		progress.Init(nbItems);
		pos = m_demoView->m_listCtrl.GetFirstSelectedItemPosition();
		for( j=0; j<nbItems; j++)
		{
			progress.m_infos.Format("Matching template %d of %d",j,nbItems);
			progress.UpdateData(false);
			index = m_demoView->m_listCtrl.GetNextSelectedItem(pos);
			index2 = m_demoView->m_indexTab[index];
			text.Format("Comparing file %s with DB template ID %s",fileName,m_demoView->m_fileNameTab[index2]);	
			m_demoView->WriteToInfoCtrl(text,false);
			timer.startTimer();
			error = dpVerifyTemplate( templBuf, m_demoView->m_templateTab[index2], &score );
			timer.stopTimer();
			totalTime += timer.getTimer();
			if( error == 1 )
			{
				m_demoView->m_scores[index2] = score;
				text.Format("Authentication SUCCESSFULL, score = %d",score);
				m_demoView->WriteToInfoCtrl(text,false);
				text.Format("Authentication time : %.2f miliseconds - Matching speed : %.0f matches/sec",timer.getTimer()*1000.0,1.0/timer.getTimer());
				m_demoView->WriteToInfoCtrl(text,false);
			}
			else if( error == 2 )
			{
				m_demoView->m_scores[index2] = -2;
				m_demoView->WriteToInfoCtrl("Authentication FAILED",false);
				text.Format("Authentication time : %.2f miliseconds - Matching speed : %.0f matches/sec",timer.getTimer()*1000.0,1.0/timer.getTimer());
				m_demoView->WriteToInfoCtrl(text,false);
			}
			else
				m_demoView->WriteToInfoCtrl("Error during authentication",false);
			progress.m_progress.StepIt();
		}
		text.Format("Total matching time : %.3f seconds",totalTime,false);
		m_demoView->WriteToInfoCtrl(text);
		text.Format("Average matching time : %.2f miliseconds - Average matching speed : %.0f",1000.0*totalTime/nbItems,nbItems/totalTime);
		m_demoView->WriteToInfoCtrl(text);
		m_demoView->UpdateListView();
		m_demoView->m_listCtrl.SetItemState( index, LVIS_SELECTED, LVIS_SELECTED ); 
		m_demoView->m_listCtrl.EnsureVisible(index,false);	
		progress.DestroyWindow();
	}
	else
		m_demoView->WriteToInfoCtrl("Please select a template to be matched with in the database !");

	delete[] templBuf;
}




