// ConfigPage.cpp : implementation file
//

#include "stdafx.h"
#include "dpBioDemo.h"
#include "ConfigPage.h"
#include "DemoConfig.h"
#include "FolderDlg.h"
#include "dpBioDemoView.h"
#include "dpBio.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

static CDpBioMainView* m_demoView;

/////////////////////////////////////////////////////////////////////////////
// CConfigPage property page

IMPLEMENT_DYNCREATE(CConfigPage, CPropertyPage)

CConfigPage::CConfigPage() : CPropertyPage(CConfigPage::IDD)
{
	//{{AFX_DATA_INIT(CConfigPage)
	m_configEditorPath = _T("");
	m_configFileDir = _T("");
	m_configFile = -1;
	//}}AFX_DATA_INIT
}

CConfigPage::~CConfigPage()
{
}

void CConfigPage::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigPage)
	DDX_Control(pDX, IDC_CONFIG_FILE, m_configFilesLstBox);
	DDX_Text(pDX, IDC_CONFIG_EDITOR, m_configEditorPath);
	DDX_Text(pDX, IDC_CONFIG_FILE_DIR, m_configFileDir);
	DDX_CBIndex(pDX, IDC_CONFIG_FILE, m_configFile);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigPage, CPropertyPage)
	//{{AFX_MSG_MAP(CConfigPage)
	ON_BN_CLICKED(IDC_CHANGE_CONFIG_DIR, OnChangeConfigDir)
	ON_CBN_SELCHANGE(IDC_CONFIG_FILE, OnSelchangeConfigFile)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConfigPage message handlers

void CConfigPage::OnChangeConfigDir() 
{
	CFolderDialog	folderDialog("Select directory where config files config files can be loaded");

	UpdateData(true);
	folderDialog.SetSelectedFolder(m_configFileDir);

	if( folderDialog.DoModal() == IDOK )
	{
		// get db path
		m_demoView->m_progConfig->m_configFileDir = folderDialog.GetFolderPath();
		m_demoView->m_progConfig->SaveConfig();

		ListConfigs( m_demoView->m_progConfig->m_configFileDir );
	}

}

BOOL CConfigPage::OnInitDialog() 
{
	CPropertyPage::OnInitDialog();

	CComboBox	*box;
	CRect		rect;

	m_demoView = (CDpBioMainView *)GetParent()->GetParent();

	box = (CComboBox *)GetDlgItem(IDC_CONFIG_FILE);
	box->GetClientRect(&rect);
	box->SetWindowPos(NULL,0,0,rect.right,256,SWP_NOOWNERZORDER|SWP_NOMOVE);
	
	if( m_demoView->m_progConfig->m_configFileDir != "" )
		ListConfigs( m_demoView->m_progConfig->m_configFileDir );

	if( m_demoView->m_progConfig->m_cfgFileNumber != -1 )
	{
		m_configFile = m_demoView->m_progConfig->m_cfgFileNumber;
		UpdateData(false);
		OnSelchangeConfigFile();
	}
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CConfigPage::ListConfigs(CString p_configDir)
{	
	WIN32_FIND_DATA	findData;
	HANDLE			findHandle;
	CString			string;
	int				loop = false;

	m_configFileDir = p_configDir;

	UpdateData(false);

	string = p_configDir + "\\*.cfg";
	
	findHandle = FindFirstFile(string,&findData);
	if( findHandle != INVALID_HANDLE_VALUE )
	{
		do
		{
			m_configFilesLstBox.AddString(findData.cFileName);
			loop = FindNextFile( findHandle, &findData );
		}
		while( loop ); 

		FindClose( findHandle );
	}


}

void CConfigPage::OnSelchangeConfigFile() 
{
	CFile			file;
	CString			fileName,txt,cfg;
	unsigned int	size;
	unsigned char	*buffer;

	UpdateData(true);

	m_demoView->m_progConfig->m_cfgFileNumber = m_configFile;
	m_demoView->m_progConfig->SaveConfig();

	if( m_configFile == 0 )
	{
		dpUnInit();
		dpInit();
		m_demoView->WriteToInfoCtrl("Default config file loaded");
		dpSetSpeed(0,0);
	}
	else
	{
		m_configFilesLstBox.GetLBText(m_configFile, cfg );
		fileName = m_configFileDir + "\\" + cfg;
		
		if( !file.Open(fileName,CFile::modeRead) )
		{
			m_demoView->WriteToInfoCtrl("Error loading config file");
			return;
		}

		file.Read(&size,sizeof(unsigned int));
		file.SeekToBegin();

		buffer = new unsigned char[size];
		file.Read(buffer,size);

		if( dpLoadParameters( buffer, size ) >= 1 )
		{
			txt.Format("Config file '%s' loaded successfully",cfg);
			m_demoView->WriteToInfoCtrl(txt);
		}
		else
			m_demoView->WriteToInfoCtrl("Invalid config file");

		delete[] buffer;

	}
}
