// DemoConfig.cpp: implementation of the CDemoConfig class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "dpBioDemo.h"
#include "DemoConfig.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CDemoConfig::CDemoConfig( CString p_appPath )
{
	int	pos;

	if( p_appPath.Right(4).Left(1) == "." )
	{
		pos = p_appPath.ReverseFind('\\');
		m_savePath = p_appPath.Left(pos+1);
		m_savePath += "dpBioDemo.dat";
	}
	else
	{
		if( p_appPath[p_appPath.GetLength()-1] == '\\' )
			m_savePath = p_appPath + "dpBioDemo.dat";
		else
			m_savePath = p_appPath + "\\dpBioDemo.dat";
	}

	m_databaseDir = "";
	m_databaseDir = "";
	m_cfgFileNumber = -1;
}

CDemoConfig::~CDemoConfig()
{

}

bool CDemoConfig::SaveConfig()
{
	CFile		file;

	// open archive
	if( !file.Open(m_savePath,CFile::modeWrite|CFile::modeCreate) )
		return false;
	CArchive	archive(&file,CArchive::store);

	// store config
	archive << m_databaseDir;
	archive << m_configFileDir;
	archive << m_cfgFileNumber;

	// close archive
	archive.Close();

	return true;
}

bool CDemoConfig::LoadConfig()
{
	CFile		file;

	// open archive
	if( !file.Open(m_savePath,CFile::modeRead) )
		return false;
	CArchive	archive(&file,CArchive::load);

	// store config
	archive >> m_databaseDir;
	archive >> m_configFileDir;
	archive >> m_cfgFileNumber;

	// close archive
	archive.Close();

	return true;
}
