// EnrollDevice.cpp : implementation file
//

#include "stdafx.h"
#include "dpBioDemo.h"
#include "EnrollDevice.h"
#include "fingerchip\FCGetImage.h"
#include "fingerchip\FC_Error.h"
#include "fingerchip\fcpublicstruct.h"
#include "gdiplus.h"
#include "dpBio.h"
#include "errorCodes.h"
#include "enrollPage.h"
#include "myFuncs.h"

/*#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif*/

/////////////////////////////////////////////////////////////////////////////
// CEnrollDevice dialog


CEnrollDevice::CEnrollDevice(CWnd* pParent /*=NULL*/)
	: CDialog(CEnrollDevice::IDD, pParent)
{
	//{{AFX_DATA_INIT(CEnrollDevice)
	m_message = _T("");
	m_templId = _T("");
	//}}AFX_DATA_INIT

	m_buffer = NULL;
	m_bitmap = NULL;
	m_loop = true;
}


void CEnrollDevice::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CEnrollDevice)
	DDX_Control(pDX, IDC_TEMPL_ID, m_templIdCtrl);
	DDX_Control(pDX, IDOK, m_ok);
	DDX_Control(pDX, IDC_MESSAGES, m_messageCtrl);
	DDX_Control(pDX, IDC_IMG_FRAME, m_imgFrame);
	DDX_Control(pDX, IDC_PROGRESS1, m_progess);
	DDX_Text(pDX, IDC_MESSAGES, m_message);
	DDX_Text(pDX, IDC_TEMPL_ID, m_templId);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CEnrollDevice, CDialog)
	//{{AFX_MSG_MAP(CEnrollDevice)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEnrollDevice message handlers

BOOL CEnrollDevice::OnInitDialog() 
{
	CDialog::OnInitDialog();
	int				i;
	unsigned int	size;

	m_gdi.Initialize();

	m_bitmap = new Gdiplus::Bitmap( 360,500,PixelFormat24bppRGB );
	
	m_buffer = new unsigned char[360*500];

	size = dpGetMaxTemplateSize();
	for(i=0; i<4; i++ )
		m_templates[i] = new unsigned char[size];

	AfxBeginThread(EnrollFunc, this );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CEnrollDevice::OnDestroy() 
{
	CDialog::OnDestroy();
	
	delete m_bitmap;
	m_gdi.Deinitialize();
	FC_CloseDevice();
	delete[] m_buffer;
	
}

int CEnrollDevice::AcquireImg()
{
	t_FC_ImageInfo	infos;
	int				error,x,y,val;

	error = FC_GetImage(  m_buffer, 360, 500, &infos );	

	for( y=0; y<500 ;y++ )
	{
		for( x=0; x<360; x++ )
		{
			val = m_buffer[y*360+x];
			m_bitmap->SetPixel(x,y,Gdiplus::Color(val,val,val));
		}
	}

	if( error != FC_OK &&  error != FC_IMAGE_TRUNCATED )
		return false;
	else
		return true;
}

void CEnrollDevice::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Gdiplus::Graphics	graphics(m_imgFrame.m_hWnd);

	if( m_bitmap != NULL )
	{
		graphics.DrawImage( m_bitmap, 0, 0 );
	}
	
}


UINT EnrollFunc( LPVOID p_param )
{
	int				i,indexTemplate,result;
	unsigned int	max,score;
	char			refined;
	CEnrollDevice	*me;

start:

	me = (CEnrollDevice*)p_param;

	max = 0;
	indexTemplate = -1;
	me->m_message = "Please wait : \r\n\r\nInitialyzing device...";
	me->UpdateData(false);
	
	
	if( FC_OpenDevice() < 0  )
	{
		me->m_message = "Unable to open device";
		me->UpdateData(false); 
		return TRUE;
	}

	Sleep(3000);

	me->m_progess.SetRange(0,4);
	me->m_progess.SetPos(0);
	me->m_progess.SetStep(1);

	me->m_message = "Step 1 of 3 : \r\n\r\nPlease sweep Finger !";
	me->UpdateData(false); 

	do
	{
		result = me->AcquireImg();
		if( !me->m_loop )
			return 1;
		me->RedrawWindow();
		if( result < 0 )
		{
			me->m_message = "Step 1 of 3 : \r\n\r\nImage acquisition error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			continue;
		}

		me->m_message = "Step 1 of 3 : \r\n\r\nPlease wait, generating template";
		me->UpdateData(false); 
		
		result = dpGenerateTemplate(me->m_buffer,360,500,me->m_templates[0]);
		if( result != ZEF_OK )
		{
			result = 0;
			me->m_message = "Step 1 of 3 : \r\n\r\nTemplate generation error\r\nPlease re-sweep Finger !";
			me->UpdateData(false);
			Sleep(2000);
			continue;
		}
	}
	while( !result );
	me->m_progess.StepIt();

	me->m_message = "Step 2 of 3 : \r\n\r\nPlease sweep Finger !";
	me->UpdateData(false); 

	do
	{
		result = me->AcquireImg();
		if( !me->m_loop )
			return 1;
		me->RedrawWindow();
		if( result < 0 )
		{
			me->m_message = "Step 2 of 3 : \r\n\r\nImage acquisition error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			continue;
		}

			FC_CloseDevice();
		if( FC_OpenDevice() < 0 )
		{
			me->m_message = "Unable to open device";
			me->UpdateData(false); 
			return TRUE;
		}

		me->m_message = "Step 2 of 3 : \r\n\r\nPlease wait, generating template";
		me->UpdateData(false); 
		
		result = dpGenerateTemplate(me->m_buffer,360,500,me->m_templates[1]);
		if( result != ZEF_OK )
		{
			result = 0;
			me->m_message = "Step 2 of 3 : \r\n\r\nTemplate generation error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			Sleep(2000);
			continue;
		}

		if( me->m_composite )
		{
			result = dpVerifyAndRefineTemplate(me->m_templates[0], me->m_templates[1], &score, &refined );
			if( result != ZEF_OK )
			{
				result = 0;
				me->m_message = "Step 2 of 3 : \r\n\r\nTemplate composition error\r\nPlease re-sweep Finger !";
				me->UpdateData(false); 
				Sleep(2000);
				continue;
			}
			if( !refined )
			{
				result = 0;
				me->m_message = "Step 2 of 3 : \r\n\r\nMatch score too low for\r\ncomposite template creation\r\nPlease re-sweep Finger !";
				me->UpdateData(false);
				Sleep(2000);
				continue;
			}
		}
	}
	while( !result );
	me->m_progess.StepIt();

	me->m_message = "Step 3 of 3 : \r\n\r\nPlease sweep Finger !";
	me->UpdateData(false); 

	do
	{
		result = me->AcquireImg();
		if( !me->m_loop )
			return 1;
		me->RedrawWindow();
		if( result < 0 )
		{
			me->m_message = "Step 3 of 3 : \r\n\r\nImage acquisition error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			continue;
		}

		FC_CloseDevice();
		if( FC_OpenDevice() < 0 )
		{
			me->m_message = "Unable to open device";
			me->UpdateData(false); 
			return TRUE;
		}

		me->m_message = "Step 3 of 3 : \r\n\r\nPlease wait, generating template";
		me->UpdateData(false); 
		
		result = dpGenerateTemplate(me->m_buffer,360,500,me->m_templates[2]);
		if( result != ZEF_OK )
		{
			result = 0;
			me->m_message = "Step 3 of 3 : \r\n\r\nTemplate generation error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			Sleep(2000);
			continue;
		}

		if( me->m_composite )
		{
			result = dpVerifyAndRefineTemplate(me->m_templates[0], me->m_templates[2], &score, &refined );
			if( result != ZEF_OK )
			{
				result = 0;
				me->m_message = "Step 3 of 3 : \r\n\r\nTemplate composition error\r\nPlease re-sweep Finger !";
				me->UpdateData(false); 
				Sleep(2000);
				continue;
			}
			if( !refined )
			{
				result = 0;
				me->m_message = "Step 3 of 3 : \r\n\r\nMatch score too low for\r\ncomposite template creation\r\nPlease re-sweep Finger !";
				me->UpdateData(false); 
				Sleep(2000);
				continue;
			}
		}
	}
	while( !result );
	me->m_progess.StepIt();

	if( me->m_composite )
	{
		me->m_message.Format("Composite Templates quality : \r\n\r\nQuality = %u",dpGetTemplateQuality(me->m_templates[0]) );	
	}
	else
	{
		me->m_message.Format("Templates quality : \r\n\r\n1st Template = %u\r\n2nd Template = %u\r\n3rd Template =%u",
			dpGetTemplateQuality(me->m_templates[0]),dpGetTemplateQuality(me->m_templates[1]),dpGetTemplateQuality(me->m_templates[2]) );
	}
	me->UpdateData(false); 
	Sleep(2000);
	if( !me->m_loop )
		return 1;

	for( i=0; i<3; i++ )
	{
		if( dpGetTemplateQuality(me->m_templates[i]) > max ) 
		{
			max = dpGetTemplateQuality(me->m_templates[i]);
			indexTemplate = i;
		}
	}

	if( !me->m_composite )
	{
		me->m_message.Format("Best template is : #%d, quality=%u",
			indexTemplate+1,dpGetTemplateQuality(me->m_templates[indexTemplate]) );
		me->UpdateData(false); 
		Sleep(2000);
		if( !me->m_loop )
			return 1;
	}

	if( dpGetTemplateQuality(me->m_templates[indexTemplate]) < 60 )
	{
		if( me->MessageBox("The quality of you best finger is below 60, this low quality could result in verification problems.\nDo you want to continue ?","Warning",MB_YESNO) == IDNO  )
		{
			goto start;
		}

	}

	me->m_indexTemplate = indexTemplate;

	me->m_message = "Enrollment verification : \r\n\r\nPlease sweep Finger !";
	me->UpdateData(false); 

	do
	{
		result = me->AcquireImg();
		if( !me->m_loop )
			return 1;
		me->RedrawWindow();
		if( result < 0 )
		{
			me->m_message = "Enrollment verification : \r\n\r\nImage acquisition error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			continue;
		}
		me->m_message = "Enrollment verification : \r\n\r\nPlease wait, performing verification";
		me->UpdateData(false);
		
		result = dpGenerateTemplate(me->m_buffer,360,500,me->m_templates[3]);
		if( result != ZEF_OK )
		{
			result = 0;
			me->m_message = "Enrollment verification : \r\n\r\nTemplate generation error\r\nPlease re-sweep Finger !";
			me->UpdateData(false); 
			Sleep(2000);
			continue;
		}
		if( me->m_composite )
			result = dpVerifyAndRefineTemplate(me->m_templates[3], me->m_templates[indexTemplate], &score, &refined );
		else
			result = dpVerifyTemplate(me->m_templates[3], me->m_templates[indexTemplate], &score );
		if( result == ZEF_OK )
		{
			me->m_message.Format("Match ok\r\nEnrollment is good ! \r\n\r\n(score = %u)", score );
			me->UpdateData(false); 
		}
		else
		{
			me->m_message = "Verification failed \r\n\r\nPlease re-Enroll";
			me->UpdateData(false); 
			goto start;
		}
	}
	while( !result );
	me->m_progess.StepIt();

	Sleep(2000);
	if( !me->m_loop )
		return 1;

	me->m_message = "Please enter Template ID \r\n\r\nThen press OK";
	me->UpdateData(false); 	

	me->m_ok.EnableWindow(true);
	me->m_templIdCtrl.EnableWindow(true);

	return 0;
}


void CEnrollDevice::OnCancel() 
{
	m_loop = false;
	FC_StopAcquisition();
	Sleep(2000);
	
	CDialog::OnCancel();
}

void CEnrollDevice::OnOK() 
{
	CString		filename;

	UpdateData(true);

	if( m_templId == "" )
	{
		AfxMessageBox("Please enter template ID before validating !");
		return;
	}


	filename = m_dbPath;
	if( filename[filename.GetLength()-1] != '\\' )
		filename += '\\';

	filename += m_templId + ".bin";

	if( !saveTemplateFile( filename, m_templates[m_indexTemplate] ) )
	{
		AfxMessageBox("Error writing template to disk...\n Perhaps duplicate template name ?") ;
		return;
	}

	CDialog::OnOK();
}


