/*******************************************************************************
*
*	Filename		:	FCCommands.h
*	Description		:	define the commands
*						Part of the SDK
*
*	Company			:	ATMEL-Grenoble
*	Project			:	FingerChip
*	Authors			:	AC	Alain Chambron
*
*	Platform		:	independant
*	Language		:	C ANSI
*	Operating System:	independant
*
*	History
*	04-AUG-2003 AC	:	extracted of FCPADStruct.h
*
*	Copyright (c)2001-2003  All rights reserved
******************************************************************************/

#ifndef __FCCOMMANDS__
#define __FCCOMMANDS__

#define ANSWER_BIT					0x8000		// response header
#define CMD_ANSWER(a)				( (a) | ANSWER_BIT )

#define CMD_GET_REVISION_INFO		0x0001
#define CMD_OPEN_DEVICE				0x0010
#define CMD_CLOSE_DEVICE			0x0011
#define CMD_GET_IMAGE				0x0012
#define CMD_STOP_ACQUISITION		0x0002
#define CMD_GET_RAW_SLICE			0x0003
#define CMD_SET_INFO				0x0004
#define CMD_GET_INFO				0x0005
#define CMD_SET_TEMP_MANAGEMENT		0x0013
#define CMD_WRITE_REG				0x0006
#define CMD_READ_REG				0x0007
#define CMD_START_NAV				0x0020
#define CMD_STOP_NAV				0x0021
#define CMD_GET_NAV					0x0022
#define CMD_CHARAC_GET_NAV_LOG		0x0023
#define CMD_CHARAC_GET_DATA_SLICES	0x0024

// SRD SPECIFIC COMMANDS

#define CMD_FLASH_IMAGE				0x0100
#define CMD_DOWNLOAD				0x0101
#define CMD_UPLOAD					0x0102
#define CMD_OPEN_BIO				0x0103
#define CMD_CLOSE_BIO				0x0104
#define CMD_GET_BIOENGINE_INFO		0x0105
#define CMD_ENROLL_START			0x0106
#define CMD_ENROLL_STEP				0x0107
#define CMD_ENROLL_STOP				0x0108
#define CMD_VERIFY					0x0109
#define CMD_VERIFY_STOP				0x010A
#define CMD_IDENTIFY_START			0x010B
#define CMD_IDENTIFY_STEP			0x010C
#define CMD_IDENTIFY_STOP			0x010D
#define CMD_OPEN_DB					0x010E
#define CMD_CLOSE_DB				0x010F
#define CMD_GET_FIRST_FINGER		0x0110
#define CMD_GET_NEXT_FINGER			0x0111
#define CMD_DELETE_FINGER			0x0112

#endif // __FCCOMMANDS__


