// IdentDevice.cpp : implementation file
//

#include "stdafx.h"
#include "dpBioDemo.h"
#include "IdentDevice.h"
#include "fingerchip\FCGetImage.h"
#include "fingerchip\FC_Error.h"
#include "fingerchip\fcpublicstruct.h"
#include "gdiplus.h"
#include "dpBio.h"
#include "errorCodes.h"
#include "myFuncs.h"
#include "HiResCounter.h"

#ifdef __cplusplus
extern "C" {
#endif
INT32 saveBmp( char *p_fileName, UINT8 *p_buffer, INT32 p_width, INT32 p_height );
#ifdef __cplusplus
}
#endif

/*#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif*/

/////////////////////////////////////////////////////////////////////////////
// CIdentDevice dialog


CIdentDevice::CIdentDevice(CWnd* pParent /*=NULL*/)
	: CDialog(CIdentDevice::IDD, pParent)
{
	//{{AFX_DATA_INIT(CIdentDevice)
	m_templId = _T("");
	m_message = _T("");
	//}}AFX_DATA_INIT
	m_threadData.m_buffer = NULL;
	m_threadData.m_bitmap = NULL;
}


void CIdentDevice::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CIdentDevice)
	DDX_Control(pDX, IDC_IMG_FRAME, m_imgFrame);
	DDX_Text(pDX, IDC_TEMPL_ID, m_templId);
	DDX_Text(pDX, IDC_MESSAGES, m_message);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CIdentDevice, CDialog)
	//{{AFX_MSG_MAP(CIdentDevice)
	ON_WM_DESTROY()
	ON_WM_PAINT()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CIdentDevice message handlers

BOOL CIdentDevice::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	m_gdi.Initialize();
	m_threadData.m_bitmap = new Gdiplus::Bitmap( 360,500,PixelFormat24bppRGB );
	m_threadData.m_buffer = new unsigned char[360*500*sizeof(unsigned char)];
	m_threadData.m_loop = true;

	dpSetDbMaxSearch(m_maxDbSearch);

	m_threadData.m_parentHandle = m_hWnd;

	AfxBeginThread(IdentFunc, &m_threadData );
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}

void CIdentDevice::OnDestroy() 
{
	CDialog::OnDestroy();
	
	delete m_threadData.m_buffer;
	delete m_threadData.m_bitmap;
	m_gdi.Deinitialize();
	
}

int AcquireImg( IdThreadData	*threadData )
{
	t_FC_ImageInfo	infos;
	int				error,x,y,val;

	error = FC_GetImage(  threadData->m_buffer, 360, 500, &infos );	

	for( y=0; y<500 ;y++ )
	{
		for( x=0; x<360; x++ )
		{
			val = threadData->m_buffer[y*360+x];
			threadData->m_bitmap->SetPixel(x,y,Gdiplus::Color(val,val,val));
		}
	}

	if( error != FC_OK &&  error != FC_IMAGE_TRUNCATED )
		return false;
	else
		return true;
}

UINT IdentFunc( LPVOID p_param )
{	
	unsigned int	score,nbTemplates,templatePos;
	int				result;
	unsigned char	templ[2048];
	char			refined;
	IdThreadData	*threadData;
	CHiResCounter	counter;

	threadData = (IdThreadData*)p_param;

	 
	threadData->m_message = "Please wait : \r\n\r\nInitialyzing device...";
	PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 );

	if( FC_OpenDevice() < 0 )
	{
		threadData->m_message = "Unable to open device";
		PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 ); 	
		return TRUE;
	}

	Sleep(3000);

	threadData->m_message = "Please sweep Finger !";
	PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 );

	do
	{
		result = AcquireImg(threadData);
		if( !threadData->m_loop )
			return 0;
		PostMessage(threadData->m_parentHandle, WM_ZEF_REFRESH,0,0 );
		if( result < 0 )
		{
			threadData->m_message = "Image acquisition error\r\nPlease re-sweep Finger !";
			PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 ); 
			continue;
		}
		threadData->m_message = "";
		PostMessage(threadData->m_parentHandle, WM_ZEF_ID,0,0 );
		threadData->m_message = "Please wait, searching into database";
		PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 ); 	

		counter.startTimer();

		result = dpGenerateTemplate(threadData->m_buffer,360,500,templ);
		if( result != ZEF_OK )
		{
			threadData->m_message = "Template generation error\r\nPlease re-sweep Finger !";
			PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 ); 
			continue;
		}
		nbTemplates = threadData->m_nbTemplates;
		result = dpIdentifyTemplate( threadData->m_templateTab, nbTemplates,templ, &score, &templatePos );

		counter.stopTimer();

		if( result != ZEF_OK )
		{
			threadData->m_message = "";
			PostMessage(threadData->m_parentHandle, WM_ZEF_ID,0,0 );
			threadData->m_message.Format("Identification failed...\r\nNo match found\r\n\r\nTime:%f sec",counter.getTimer());
			PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 );
		}
		else
		{
			threadData->m_message = threadData->m_fileNameTab[templatePos];
			PostMessage(threadData->m_parentHandle, WM_ZEF_ID,0,0 );
			threadData->m_message.Format("Identification sucessful...\r\n\r\nScore = %u\r\n\r\nTime:%f sec",score,counter.getTimer());
			PostMessage(threadData->m_parentHandle, WM_ZEF_MSG,0,0 );
			// test
			dpVerifyAndRefineTemplate( threadData->m_templateTab[templatePos], templ, &score, &refined );
			//saveTemplateFile( "c:\\composite.bin", me->m_templateTab[nbTemplates] );
			//saveBmp( "c:\\composite.bmp",me->m_buffer, 360, 500 );
		}
	}
	while( threadData->m_loop );

	FC_CloseDevice();

	return 0;
}

void CIdentDevice::OnPaint() 
{
	CPaintDC dc(this); // device context for painting
	
	Gdiplus::Graphics	graphics(m_imgFrame.m_hWnd);

	if( m_threadData.m_bitmap != NULL )
	{
		graphics.DrawImage( m_threadData.m_bitmap, 0, 0 );
	}	
}

void CIdentDevice::OnCancel() 
{
	m_threadData.m_loop = false;
	FC_StopAcquisition();
	Sleep(1000);
	
	CDialog::OnCancel();
}

LRESULT CIdentDevice::WindowProc(UINT message, WPARAM wParam, LPARAM lParam) 
{
	switch( message )
	{
	case WM_ZEF_MSG:
		UpdateData(true);
		m_message = m_threadData.m_message;
		UpdateData(false);
		break;
	case WM_ZEF_REFRESH:
		RedrawWindow();
		break;
	case WM_ZEF_ID:
		UpdateData(true);
		m_templId = m_threadData.m_message;
		UpdateData(false);
		break;
	}

	return CDialog::WindowProc(message, wParam, lParam);
}
