// dpBioDemoView.h : interface of the CDpBioMainView class
//
/////////////////////////////////////////////////////////////////////////////

#if !defined(AFX_DPBIODEMOVIEW_H__9EED5E4F_8E18_4EB7_B661_48FF69B5A1E9__INCLUDED_)
#define AFX_DPBIODEMOVIEW_H__9EED5E4F_8E18_4EB7_B661_48FF69B5A1E9__INCLUDED_

#include "BenchPage.h"	// Added by ClassView
#include "AuthentPage.h"	// Added by ClassView
#include "EnrollPage.h"	// Added by ClassView
#include "ConfigPage.h"	// Added by ClassView
#include "DemoConfig.h"
#include "customTypes.h"
#include "DpBioDemoDoc.h"
#include "IdentifyPage.h"	// Added by ClassView

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000


class CDpBioMainView : public CFormView
{
protected: // create from serialization only
	CDpBioMainView();
	DECLARE_DYNCREATE(CDpBioMainView)

public:
	//{{AFX_DATA(CDpBioMainView)
	enum { IDD = IDD_DPBIODEMO_FORM };
	CEdit	m_infosCtrl;
	CListCtrl	m_listCtrl;
	CStatic	m_tabControlBox;
	CString	m_databaseDir;
	//}}AFX_DATA

// Attributes
public:
	CDpBioDemoDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CDpBioMainView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	virtual BOOL OnPreparePrinting(CPrintInfo* pInfo);
	virtual void OnBeginPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnEndPrinting(CDC* pDC, CPrintInfo* pInfo);
	virtual void OnPrint(CDC* pDC, CPrintInfo* pInfo);
	//}}AFX_VIRTUAL

// Implementation
public:
	void Refresh(void);
	CBenchPage m_benchPage;
	CIdentifyPage m_identPage;
	void LoadDatabase( CString p_dbPath );
	int * m_scores;
	void UpdateListView(void);
	void InitListView(void);
	int m_nbTemplates;
	unsigned char** m_templateTab;
	unsigned int * m_indexTab;
	unsigned int * m_globDist;
	unsigned int * m_coreIndexTab;
	unsigned int * m_coreGlobDist;
	CString * m_fileNameTab;
	void WriteToInfoCtrl( CString p_message, bool p_redraw = true );
	CDemoConfig * m_progConfig;
	CConfigPage m_configPage;
	CPropertySheet m_propSheet;
	CEnrollPage m_enrollPage;
	CAuthentPage m_authentPage;
	virtual ~CDpBioMainView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:

// Generated message map functions
protected:
	//{{AFX_MSG(CDpBioMainView)
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnChooseDatabase();
	afx_msg void OnSelectAll();
	afx_msg void OnRefresh();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

#ifndef _DEBUG  // debug version in dpBioDemoView.cpp
inline CDpBioDemoDoc* CDpBioMainView::GetDocument()
   { return (CDpBioDemoDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_DPBIODEMOVIEW_H__9EED5E4F_8E18_4EB7_B661_48FF69B5A1E9__INCLUDED_)
