// dpBioToolsDlg.cpp : implementation file
//

#include "stdafx.h"
#include "dpBioTools.h"
#include "dpBioToolsDlg.h"
#include "FolderDlg.h"
#include "myFuncs.h"
#include "dpBio.h"
#include "binStatDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDpBioToolsDlg dialog

CDpBioToolsDlg::CDpBioToolsDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDpBioToolsDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDpBioToolsDlg)
	m_infos = _T("");
	m_meanTime = 0.0f;
	m_totalTime = 0.0f;
	m_oldGabFlag = FALSE;
	m_sourcePath = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDpBioToolsDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDpBioToolsDlg)
	DDX_Control(pDX, IDC_BIN_STATS, m_binStats);
	DDX_Control(pDX, IDC_GENRATE, m_generate);
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	DDX_Text(pDX, IDC_INFOS, m_infos);
	DDX_Text(pDX, IDC_MEAN_TIME, m_meanTime);
	DDX_Text(pDX, IDC_TOTAL_TIME, m_totalTime);
	DDX_Check(pDX, IDC_OLD_GAB, m_oldGabFlag);
	DDX_Text(pDX, IDC_PATH, m_sourcePath);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDpBioToolsDlg, CDialog)
	//{{AFX_MSG_MAP(CDpBioToolsDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_SRC_SELECT, OnSrcSelect)
	ON_BN_CLICKED(IDC_GENRATE, OnGenrate)
	ON_BN_CLICKED(IDC_CONFIG, OnConfig)
	ON_BN_CLICKED(IDC_BIN_STATS, OnBinStats)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDpBioToolsDlg message handlers

BOOL CDpBioToolsDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// my Inits

	m_progress.SetRange32(0,100);
	m_progress.SetPos(0);
	m_progress.SetStep(1);

	// init bioEngine
	dpInit();

	//dpSetSpeed(0,2);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDpBioToolsDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDpBioToolsDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDpBioToolsDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDpBioToolsDlg::OnSrcSelect() 
{
	CFolderDialog	folderDlg("Veuillez slectionner le rpertoire source");
	int				cpt=0;

	UpdateData(true);

	if( folderDlg.DoModal() == IDOK )
	{
		BeginWaitCursor();
		m_sourcePath = folderDlg.GetFolderPath();
		m_infos = "Analyse du contenu du dossier...";

		cpt = getNbFiles(m_sourcePath.GetBuffer(256), ".bmp" );
		m_sourcePath.ReleaseBuffer();

		m_nbFiles = cpt;
		m_progress.SetRange32(0,cpt);
		m_infos.Format("Analyse termine : %d images trouves",cpt);

		EndWaitCursor();
		UpdateData(false);
	}
	
	m_generate.EnableWindow(true);
	m_binStats.EnableWindow(true);
}

void CDpBioToolsDlg::OnGenrate() 
{
	UpdateData(true);
	getNbFiles(m_sourcePath.GetBuffer(256), ".bmp", true, this, m_oldGabFlag );
	m_sourcePath.ReleaseBuffer();
	m_progress.SetPos(0);
}

BOOL CDpBioToolsDlg::DestroyWindow() 
{
	dpUnInit();
	
	return CDialog::DestroyWindow();
}

void CDpBioToolsDlg::OnConfig() 
{
	CString			string;
	CFile			file;
	unsigned int	size;
	unsigned char	*buffer;
	short			status=0;
	CFileDialog		fileDlg(true,"cfg",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Config file (*.cfg);*.cfg||");

	
	if( fileDlg.DoModal() == IDOK )
	{
		string = fileDlg.GetPathName();
		file.Open(string,CFile::modeRead);
		file.Read(&size,sizeof(unsigned int));
		file.SeekToBegin();
		buffer = new unsigned char[size];
		file.Read(buffer,size);
		file.Close();

		if( dpLoadParameters( buffer, size ) != 1 )
			status = 1;

		delete[] buffer;

		AfxMessageBox("Config Loaded !");

	}
}

void CDpBioToolsDlg::OnBinStats() 
{
	CBinStatDlg	dlg;

	dlg.m_nbFiles = m_nbFiles;
	dlg.m_sourcePath = m_sourcePath;
	dlg.DoModal();
	
}
