#include "myFuncs.h"
#include "BMPfiles.h"
#include "dpBio.h"
#include "compatibility.h"
#include "tools.h"

int getNbFiles( char *p_directory, char *p_extension, bool p_generate, CDpBioToolsDlg *p_parent, bool p_oldGab )
{
	WIN32_FIND_DATA	findData;
	HANDLE			findHandle;
	CString			string;
	int				cpt=0;
	int				loop,t1,t2;
	static float	totalTime=0.0;
	static int		sCpt=0;
	int				error;

	// recurse subdirectories
	string = CString(p_directory) + "\\*";
	
	findHandle = FindFirstFile(string,&findData);
	if( findHandle != INVALID_HANDLE_VALUE )
	{
		do
		{
			if( findData.dwFileAttributes|FILE_ATTRIBUTE_DIRECTORY && strcmp(findData.cFileName,".") && strcmp(findData.cFileName,"..") )
			{
				string = CString(p_directory) + "\\" + CString(findData.cFileName);
				cpt+= getNbFiles( string.GetBuffer(256), p_extension, p_generate, p_parent, p_oldGab );
				string.ReleaseBuffer();
			}
			loop = FindNextFile( findHandle, &findData );
		}
		while( loop ); 

		FindClose( findHandle );
	}

	// now search for "extension" in the directory
	string = CString(p_directory) + "\\*" + CString(p_extension);
	
	findHandle = FindFirstFile(string,&findData);
	if( findHandle != INVALID_HANDLE_VALUE )
	{
		do
		{
			cpt++;
			sCpt++;
			if( p_generate )
			{	
				string = CString(p_directory) + "\\" + CString(findData.cFileName);
				p_parent->m_infos.Format("Fichier : %s", string );
				p_parent->m_progress.StepIt();
				p_parent->UpdateData(false);
				t1 = GetTickCount();
				error = genWriteTemplate( string.GetBuffer(256), p_oldGab );
				t2 = GetTickCount();
				if( error != 1 )
					return -1;
				totalTime += float((t2-t1)/1000.0);
				p_parent->m_meanTime = totalTime/sCpt;
				p_parent->m_totalTime = totalTime*(p_parent->m_nbFiles-sCpt)/(float)sCpt;
				p_parent->UpdateData(false);
				p_parent->RedrawWindow();
				string.ReleaseBuffer();
			}
			loop = FindNextFile( findHandle, &findData );
		}
		while( loop ); 

		FindClose( findHandle );
	}

	if( p_generate && cpt == p_parent->m_nbFiles )
	{
		p_parent->m_infos.Format("Extraction termine, temps total : %f secondes",totalTime);
		p_parent->UpdateData(false);
		totalTime=0.0;
		sCpt=0;
	}

	if( !p_generate )
	{
		totalTime=0.0;
		sCpt=0;
	}
	
	return cpt;
}

int genWriteTemplate( char *p_fileName, bool p_oldGab )
{
	int				error;
	unsigned int	temSize;
	int				size,width,height;
	unsigned char	*buffer;
	unsigned char	theTemplate[1024];
	unsigned char	oldTemplate[1024];
	CFile			file;
	CString			string;

	error = getBmpSize( p_fileName, &size );
	if( error != 1 )
		return error;

	buffer = new unsigned char[size];

	error = loadBmp( p_fileName, buffer, size, &width, &height );
	if( error != 1 )
	{
		delete[] buffer;
		return error;
	}

	error = dpGenerateTemplate( buffer, width, height, theTemplate );
	if( error != 1 )
	{
		delete[] buffer;
		return error;
	}

	string = CString(p_fileName);
	string = string.Left(string.GetLength()-3) + "bin";

	if( p_oldGab )
	{
		convertToOldGabV2( theTemplate, oldTemplate );
		temSize = sizeof( GabaritV2 );

		if( !file.Open( string, CFile::modeWrite|CFile::modeCreate ) )
		{
			delete[] buffer;
			return -1;
		}

		file.Write( oldTemplate, temSize );
		
		file.Close();

	}
	else
	{
		temSize = ((long*)theTemplate)[0];

		if( !file.Open( string, CFile::modeWrite|CFile::modeCreate ) )
		{
			delete[] buffer;
			return -1;
		}

		file.Write( theTemplate, temSize );
		
		file.Close();
	}

	delete[] buffer;

	return 1;
} 


int fillTabs( char *p_directory, char *p_extension, CString *p_fileNameTab, int *p_indexTab, Template *p_templateTab, bool first )
{
	WIN32_FIND_DATA	findData;
	HANDLE			findHandle;
	CString			string;
	int				cpt=0;
	int				loop;
	static int		sCpt=0;
	CFile			file;
	unsigned int	size;
	unsigned char	buffer[1024];
	static CString	path;

	if( first )
	{
		path = p_directory;
		sCpt=0;
	}		

	// recurse subdirectories
	string = CString(p_directory) + "\\*";
	
	findHandle = FindFirstFile(string,&findData);
	if( findHandle != INVALID_HANDLE_VALUE )
	{
		do
		{
			if( findData.dwFileAttributes|FILE_ATTRIBUTE_DIRECTORY && strcmp(findData.cFileName,".") && strcmp(findData.cFileName,"..") )
			{
				string = CString(p_directory) + "\\" + CString(findData.cFileName);
				cpt+= fillTabs( string.GetBuffer(256), p_extension, p_fileNameTab, p_indexTab, p_templateTab,false );
				string.ReleaseBuffer();
			}
			loop = FindNextFile( findHandle, &findData );
		}
		while( loop ); 

		FindClose( findHandle );
	}

	// now search for "extension" in the directory
	string = CString(p_directory) + "\\*" + CString(p_extension);
	
	findHandle = FindFirstFile(string,&findData);
	if( findHandle != INVALID_HANDLE_VALUE )
	{
		do
		{
	
			// read file
			string = CString(p_directory) + "\\" + CString(findData.cFileName);
			file.Open( string, CFile::modeRead );
			file.Read(&size, sizeof(unsigned int));
			file.SeekToBegin();
			file.Read(buffer, size);
			file.Close();

			// unpack template and save infos to arrays
			p_indexTab[sCpt] = sCpt;
			templateInit( &(p_templateTab[sCpt]) );
			templateUnpacker( buffer, &(p_templateTab[sCpt]) );
			p_fileNameTab[sCpt] = string.Right(string.GetLength()-path.GetLength()-1);

			cpt++;
			sCpt++;

			loop = FindNextFile( findHandle, &findData );
		}
		while( loop ); 

		FindClose( findHandle );
	}

	
	
	return cpt;
}


int segmenter( float *p_tab, int *p_index,  int p_taille )
//	Fonction pour segmenter le tableau en 2 ss-tableaux
//	retourne l'indice du pivot

{
	float pivot = p_tab[ p_taille/2 ];
	int indPivot = p_taille/2;
	int i, j, tmp2;
	float tmp;
	
	i=0;
	j=p_taille-1;
	
	while( i<j )
	{	
		while( p_tab[i] <= pivot && i < indPivot) i++;
		while( p_tab[j] >= pivot && j > indPivot && i<j) j--;

		if( i == indPivot ) indPivot=j;
		else if( j == indPivot ) indPivot=i;
		tmp = p_tab[i];
		p_tab[i] = p_tab[j];
		p_tab[j] = tmp;
		tmp2 = p_index[i];
		p_index[i] = p_index[j];
		p_index[j] = tmp2;
	}
	return indPivot;
}

void trier( float *p_tab, int *p_index, int p_borneInf, int p_borneSup )
// Procedure pour trier un tableau
{
	int i;
	
	i=segmenter( p_tab+p_borneInf, p_index+p_borneInf, p_borneSup-p_borneInf+1 );

	if( p_borneSup-p_borneInf>1 )
	{
		trier( p_tab, p_index, p_borneInf, p_borneInf+i);
		trier( p_tab, p_index, p_borneInf+i, p_borneSup );
	}
}
