/// 
/// ****** bioengine routines: signature extraction and pair comparison evaluation
///

#include "stdafx.h"
#include "Far_frr_evaluation2.h"
#include "Far_frr_evaluation2Dlg.h"
#include "BioEngine.h"
#include "dpBio.h"

extern bool g_readBin;

short loadParameters()
{
	WIN32_FIND_DATA	findData;
	HANDLE			findHandle;
	CString			string;
	CFile			file;
	unsigned int	size;
	unsigned char	*buffer;
	short status=0;

	// if there is a .cfg file in the current directory : read it
	string = "*.cfg";	
	findHandle = FindFirstFile(string,&findData);
	if( findHandle != INVALID_HANDLE_VALUE )
	{
		string = CString(findData.cFileName);
		file.Open(string,CFile::modeRead);
		file.Read(&size,sizeof(unsigned int));
		file.SeekToBegin();
		buffer = new unsigned char[size];
		file.Read(buffer,size);
		file.Close();

		if( dpLoadParameters( buffer, size ) != 1 )
			status = 1;
		dpSetSecurity(0);

		delete[] buffer;

		FindClose( findHandle );
	}
	else
		status = 1;

	return status;
}

short CFar_frr_evaluation2Dlg::Bioengine_initialize(char *mess, char *version)
{
	// put here all the initialization requested for your bioengine
	// this function is called only once at the very beginning of the application
	short status=0;
	strcpy(version,dpGetEngineVersion()); // load in version the bioengine version identificator (40 char max)

	dpInit();
	dpSetSecurity(0);
	UpdateData(TRUE);
	
	if (status)
		strcpy(mess,"ERROR: something goes wrong during initialization"); // this message will be displayed at init
	return status;
}
short CFar_frr_evaluation2Dlg::Bioengine_finish(char *mess)
{
	// this fucntion is called once, at the end of the test
	short status=0;
	
	dpUnInit();
	
	if (status)
		strcpy(mess,"ERROR: something goes wrong when finishing"); // this message will be displayed at init
	return status;
}

unsigned char pixels[MAXPIXEL];		 // input image
#define XNEW 400					 // choose your new image size 
#define YNEW 500
unsigned char pixextract[XNEW*YNEW]; // final image

short CFar_frr_evaluation2Dlg::Bioengine_ExtractSignature(
		char *bmpname,			  // bitmap name : input
		long *xsize, long *ysize, // size of image to return
		unsigned char *signature, // signature buffer to return
		char *mess)				  // error message to return, displayed if return value is not null
{
	short			status = 0;
	unsigned int	len;
	FILE			*file;
	int				error;

	if( !g_readBin )
	{
		status = ReadBmp(bmpname, pixels, xsize, ysize); // read the bitmap
		if (status)
		{
			strcpy(mess, "cannot read bitmap");
			return (status);
		}

		// RETOURNEMENT PLUS UTILE CAR DEJA FAIT LORS DU CHARGEMENT DU BMP
		/*for( int y=0; y<*ysize/2; y++)
		{
			for( int x=0; x<*xsize; x++)
			{
				temp = pixels[y*(*xsize)+x];
				pixels[y*(*xsize)+x] = pixels[(*ysize-1-y)*(*xsize)+x];
				pixels[(*ysize-1-y)*(*xsize)+x] = temp;
			}
		}*/
		// for the FingerChip, resolution is always 500 dpi (513 exactly, 50 microns per pixel)
		// last parameter <0 makes the image upside-down (as the bitmap is upside-down!)
		// you can change the destination size to your values, if needed
		/*Clip_image(pixels, *xsize, *ysize, pixextract, XNEW, -YNEW);
		*xsize = XNEW; *ysize = YNEW; // update the value for later use, during comparison (if needed!)*/
		memset(signature,0,BIOENGINE_SIGNATURE_SIZE); // reset the signature content
		error = dpGenerateTemplate(pixels, *xsize, *ysize, signature);
		if( error < 1 )
			status = 1;

		// on sauve les .bin
		/*len = strlen(bmpname);
		bmpname[len-3] = 'b';
		bmpname[len-2] = 'i';
		bmpname[len-1] = 'n';

		file = fopen(bmpname,"wb");
		if( file == NULL )
		{
			strcpy(mess,".bin save failed");
			return -1;
		}
		
		len = dpGetTemplateSize(signature);
		fwrite(signature,len,1,file);

		fclose(file);*/

	}
	else // on lit les.bin
	{
		// on lit qd mme le bmp pour des raisons de timing !
		status = ReadBmp(bmpname, pixels, xsize, ysize); // read the bitmap

		len = strlen(bmpname);
		bmpname[len-3] = 'b';
		bmpname[len-2] = 'i';
		bmpname[len-1] = 'n';

		file = fopen(bmpname,"rb");
		if( file == NULL )
		{
			strcpy(mess,".bin open failed");
			return -1;
		}
		
		fread(&len,sizeof(unsigned int),1,file);
		fseek(file,0,SEEK_SET);
		fread(signature,len,1,file);

		fclose(file);
	}

	if (status)
	{
		sprintf(mess,"error during parameters extraction, code = %d",error);
	}
	return(status);



}

short CFar_frr_evaluation2Dlg::Bioengine_Score(
		unsigned char *sign1, long xsize1, long ysize1, char *bmpname1, // signature, size and name of bitmap 
		unsigned char *sign2, long xsize2, long ysize2, char *bmpname2,
		long *score, // returned score
		char *mess)  // error message to return, displayed if return value is not null
{
	int			error;
	short		status = 0;
	unsigned int	myScore;

	/*char buf[1024];
	sprintf(buf,"%s - %s",bmpname1,bmpname2);
	reportError(buf);*/

	error = dpVerifyTemplate( sign1, sign2, &myScore );
	*score = (long)myScore;

	if( error < 1 )
		status = 1;

	// give two signature, return a score
	
	if (status)
	{
		sprintf(mess,"error during matching, code = %d",error);
		*score = 0;
	}
	return(status);				
}
