// to be included in far_frr_evaluation2Dlg.cpp (exclude from build)
// not very frequently changed routines... maybe adapted for a specific bioengine
// with unregular test routines
// release 2.16

// ************* Extract and compare routines
unsigned char sign1[BIOENGINE_SIGNATURE_SIZE];
unsigned char sign2[BIOENGINE_SIGNATURE_SIZE];

//#undef NDEBUG

short CFar_frr_evaluation2Dlg::Extract(long idfile, short signa, long idsign)
{
	// read the bitmap idfile and store the minutia in memory
	char tmp1[256];
	short status = Bioengine_ExtractSignature(bmp[idfile].name, 
											 &bmp[idfile].xsize, &bmp[idfile].ysize, 
											  sign1, tmp1);
	// copy in destination 
	switch (signa)
	{
	case 1: memcpy(signature_first[idsign].data,  sign1, sizeof(sign1));
			       signature_first[idsign].id = idfile;
			break;
	case 2: memcpy(signature_finger[idsign].data, sign1, sizeof(sign1));
			       signature_finger[idsign].id = idfile;
			break;
	default: status = 9999; // should never happen
			break;
	}
	if (status)
	{
		sprintf(tmp,"ERROR %i bioengine/extraction %s at file %s",status,tmp1,bmp[idfile].name);
		Log_mess(tmp);
	}
	return(0);
}


short CFar_frr_evaluation2Dlg::FarTest(long idtest)
{
	// test the current image against all first bitmap
	CString scoreStr;
	long i,k;
	for (i=0; i<lC001; i++) // against the first minutiae
	{
		_splitpath( bmp[idtest].name,                drive1, dir1, fname1, ext1 );
		_splitpath( bmp[signature_first[i].id].name, drive2, dir2, fname2, ext2 );
		int cmp = strcmp(dir1,dir2);
		if ( cmp<0 || (cmp && bmp[idtest].first<=0) ) // not the same finger
		{
			// copy the signature, to make sure
			if (bmp[idtest].first>0)
				memcpy(sign1,signature_first [bmp[idtest].idsign].data,BIOENGINE_SIGNATURE_SIZE);
			else
				memcpy(sign1,signature_finger[bmp[idtest].idsign].data,BIOENGINE_SIGNATURE_SIZE);
			memcpy(sign2,signature_first[i].data, BIOENGINE_SIGNATURE_SIZE);
			long score=0;
			short status;
			char tmp1[256];
			status = Bioengine_Score(	
				sign1, bmp[idtest               ].xsize, bmp[idtest               ].ysize, bmp[idtest               ].name,
				sign2, bmp[signature_first[i].id].xsize, bmp[signature_first[i].id].ysize, bmp[signature_first[i].id].name,
				&score, tmp1);
			if (status)
			{
				sprintf(tmp,"ERROR %i bioengine/match %s files %s %s",	status, tmp1, bmp[idtest].name, bmp[signature_first[i].id].name);
				Log_mess(tmp);
			}
	
			scoreStr.Format("%d\n",score);
			farFile.WriteString(scoreStr);

			// count the results
#if NDEBUG
			if (score>=lTFAR)
#endif
			{
				sprintf(tmp,"FAR %7i %s %s", score, bmp[idtest].name, bmp[signature_first[i].id].name);
				Log_mess(tmp);
			}
			for (k=0;k<THRS_STEP;k++)
				if (score>= lThrs[k])		// above or equal means a positive match
					lCfar[k]++;
			if (WatchDog(lFrr+lFar, lTest)) return(1);
			lTest++; lTestFar++;

			// additional tests for the scoring
			for (k=0;k<THFAR;k++)
				if (score>= thlevel[k])		// above or equal means a positive match
					lCfarScore[k]++;
		}
	}
	return(0);
}

short CFar_frr_evaluation2Dlg::FrrTest(long num)
{
	// test the frr half matrix, starting from idsign, with num images
	// compute also a scoring for each image
	CString scoreStr;
	long i,j,k;
	if (num>=MAXSAMEFINGER)
	{
		Log_mess("Too much images for one finger, recompile!");
		return (-1);
	}

	for (i=0;   i<num; i++)
	for (j=i+1; j<num; j++)
	{
		// copy the signature, to make sure
		memcpy(sign1,signature_finger[i].data,BIOENGINE_SIGNATURE_SIZE);
		memcpy(sign2,signature_finger[j].data,BIOENGINE_SIGNATURE_SIZE);
		long score=0;
		short status;
		char tmp1[256];
		status = Bioengine_Score(	
			sign1, bmp[signature_finger[i].id].xsize,bmp[signature_finger[i].id].ysize, bmp[signature_finger[i].id].name,
			sign2, bmp[signature_finger[j].id].xsize,bmp[signature_finger[j].id].xsize, bmp[signature_finger[j].id].name,
			&score, tmp1);
		lscore[i][j]=score;
		if (status)
		{
			sprintf(tmp,"ERROR %i bioengine/match %s files %s %s",	status, tmp1, 
							bmp[signature_finger[i].id].name, 
							bmp[signature_finger[j].id].name);
			Log_mess(tmp);
		}
		scoreStr.Format("%d\n",score);
		frrFile.WriteString(scoreStr);
		// count the results
#if NDEBUG
		if (score<=lTFRR)
#endif
		{
			sprintf(tmp,"FRR %7i %s %s", score, bmp[signature_finger[i].id].name, 
												bmp[signature_finger[j].id].name);
			Log_mess(tmp);
		}
		for (k=0;k<THRS_STEP;k++)
			if (score< lThrs[k])		// below means a negative match (equals is a positive match)
				lCfrr[k]++;
		if (WatchDog(lFrr+lFar, lTest)) return(1);
		lTest++; lTestFrr++;
	}

	// the scoring is computed in frrTestScoring()
	FrrTestScoring(num);
	return(0);
}

