// Far_frr_evaluation2Dlg.cpp : implementation file
//

#include "stdafx.h"
#include "Far_frr_evaluation2.h"
#include "Far_frr_evaluation2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#include <direct.h>
#include <io.h>
#include <time.h>
#include <math.h> // log10

#include "BioEngine.h"
#include "dpBio.h"

#define VERSION "2.16"	    // version of the present code
// release 2.15: added in the score file if the image match or don't match with image 001
// release 2.16 26-jan-2002: add extract_far_frr in ressource to avoid the non-saving
//							 add comment in extract_far_frr to recognize 
//							 separate the scoring and create a new function, to help change later

char BIOENGINE_VERSION[40];	// the release of the bioengine

CString szSumfilename;			// summary file
CString szLogfilename;			// log file
CString szScofilename;			// scoring file
CStdioFile logfile, sumfile, scofile,farFile,frrFile;
CFileException fileException,reportException;

bool g_readBin=false;

char  curdir  [_MAX_PATH];	// current directory

char  drive1  [_MAX_DRIVE];	// drive
char  dir1    [_MAX_DIR];	// directory
char  fname1  [_MAX_FNAME];	// filename
char  ext1    [_MAX_EXT];	// extension

char  drive2  [_MAX_DRIVE];	// drive
char  dir2    [_MAX_DIR];	// directory
char  fname2  [_MAX_FNAME];	// filename
char  ext2    [_MAX_EXT];	// extension

struct _finddata_t c_file1, c_file2;
long hFile1, hFile2;
char tmp[2560];  //temporary string

long lCbmp;
long lC001;
long lFrr,lFar;
double dFrr, dFrr1, dFar, dFar1, dBmp;
clock_t start, finish;;
char tmpbuf1[128], tmpbuf2[128];
long lTest, lTestFar, lTestFrr;

#define THRS_STEP 10
long lCfar[THRS_STEP]; // above threshold
long lCfrr[THRS_STEP]; // below
long lThrs[THRS_STEP]; // thresholds
long lTFAR, lTFRR;	   // report info

#define THFAR 3 // number of scoring level
long thlevel[THFAR];
long lCfarScore[THFAR];

#define MAXBITMAP     13000	// maximum number of bitmaps
#define MAXFINGER      1000 // maximum number of first files
#define MAXSAMEFINGER   300 // maximum number of image for one finger

long lscore[MAXSAMEFINGER][MAXSAMEFINGER];	// to store the scores
  
struct BITMAPLIST
{
char name  [_MAX_PATH];	// list of bitmap names
long first;				// is it a first file?
long idsign;			// address of the signature
long xsize,ysize;		// size of bitmap
}	bmp[MAXBITMAP];

long bmpsorted[MAXBITMAP];			 // will contain the bitmap sorted in order

struct SIGNATURE
{
long id;							 // idnumber of the bitmap
char data[BIOENGINE_SIGNATURE_SIZE]; // big memory location to store minutiae
}	;

SIGNATURE signature_first [MAXFINGER];		// array for FAR
SIGNATURE signature_finger[MAXSAMEFINGER];  // array for FRR

short selected=0;

// to display the graph
HPEN hpen0, hpen1, hpen2, hpen3;
CDC *pDC;

#define SAMPLEFAR 80	// this will divide the number of FAR tests (so faster, useful for scoring)

/////////////////////////////////////////////////////////////////////////////
// CFar_frr_evaluation2Dlg dialog

CFar_frr_evaluation2Dlg::CFar_frr_evaluation2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CFar_frr_evaluation2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CFar_frr_evaluation2Dlg)
	m_main_mess = _T("");
	m_database = _T("");
	m_nfrr = 0;
	m_nfar = 0;
	m_bioengine_company = _T("");
	m_bioengine_version = _T("");
	m_samplefar = FALSE;
	m_fvcMode = FALSE;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CFar_frr_evaluation2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CFar_frr_evaluation2Dlg)
	DDX_Control(pDX, IDC_SPEED, m_speed);
	DDX_Control(pDX, IDC_PICT, m_pict);
	DDX_Text(pDX, IDC_MAIN_MESS, m_main_mess);
	DDX_Text(pDX, IDC_DATABASE, m_database);
	DDX_Text(pDX, IDC_NFRR, m_nfrr);
	DDX_Text(pDX, IDC_NFAR, m_nfar);
	DDX_Text(pDX, ID_BIOENGINE_COMPANY, m_bioengine_company);
	DDX_Text(pDX, ID_BIOENGINE_VERSION, m_bioengine_version);
	DDX_Check(pDX, IDC_SAMPLEFAR, m_samplefar);
	DDX_Check(pDX, IDC_FVC, m_fvcMode);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CFar_frr_evaluation2Dlg, CDialog)
	//{{AFX_MSG_MAP(CFar_frr_evaluation2Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDSELECT, OnSelect)
	ON_BN_CLICKED(IDRUN, OnRun)
	ON_BN_CLICKED(IDREADSUM, OnReadsum)
	ON_BN_CLICKED(IDC_READBIN, OnReadbin)
	ON_CBN_SELCHANGE(IDC_SPEED, OnSelchangeSpeed)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CFar_frr_evaluation2Dlg message handlers

BOOL CFar_frr_evaluation2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	hpen0 = CreatePen(PS_SOLID, 1, RGB(100, 100, 100)); // grey; 
	hpen1 = CreatePen(PS_SOLID, 1, RGB(255,   0,   0)); // red; 
	hpen2 = CreatePen(PS_SOLID, 1, RGB(  0,   0,   0)); // black; 
	hpen3 = CreatePen(PS_SOLID, 1, RGB(  0, 255,   0)); // green; 
	pDC=m_pict.GetDC();

	if (Bioengine_initialize(tmp,BIOENGINE_VERSION))	// if some initialization are required
		Display_mess(tmp);

	sprintf(tmp,"Far_frr_evaluation2 Atmel with %s bioengine release %s",BIOENGINE_NAME, BIOENGINE_VERSION);
	SetWindowText(tmp);
	sprintf(tmp,"Far_frr_evaluation2 version %s compiled %s\n",VERSION,COMPILE_DATE);
	Display_mess(tmp);	
	
	m_bioengine_company = BIOENGINE_NAME;
	m_bioengine_version = BIOENGINE_VERSION;
	m_samplefar = FALSE;
	Display_mess("Select a database");

	m_speed.SetCurSel(0);
	UpdateData(false);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CFar_frr_evaluation2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		DrawFarFrr();
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CFar_frr_evaluation2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

#define MAXDISPLINE 19	// number of comment lines to display 
#define MAXMESS 256*100
char dsp[MAXDISPLINE][MAXMESS]; //temporary string
char messdis[MAXMESS*MAXDISPLINE]; // message

void CFar_frr_evaluation2Dlg::Display_mess(char *message)
{
	// this function display the lines in main_mess, adding message
	// line 0 is the upper first line
	short i;
	char *ret;
	char *loc;

	loc = message;
	ret=strchr(loc,'\n');
	while ( ret || *loc )
	{
		if (strncmp(dsp[MAXDISPLINE-1],"RUN",3) || strncmp(message,"RUN",3) )
				for(i=0;i<MAXDISPLINE-1;i++) 
					strcpy(dsp[i],dsp[i+1]); // shift lines

		if (ret)
		{
			strncpy(dsp[MAXDISPLINE-1],loc,ret-loc);
			dsp[MAXDISPLINE-1][ret-loc]='\0';
			loc = ret + 1;
		}
		else
		{
			strcpy(dsp[MAXDISPLINE-1],loc);
			loc = loc + strlen(loc);
		}
		ret=strchr(loc,'\n');
	}

	strcpy(messdis,""); // create the message to display
	for(i=0;i<MAXDISPLINE;i++)
	{
		strcat(messdis,dsp[i]);
		strcat(messdis,"\r\n");
	};
	m_main_mess = messdis; // display
	UpdateData(FALSE); 
	UpdateWindow();
}

char messlog[MAXMESS];
void CFar_frr_evaluation2Dlg::Log_mess(char *message)
{
	// display and include the message in the log file
	strcpy(messlog, message);
	Display_mess(messlog);
	strcat(messlog,"\n");
	logfile.WriteString(messlog);	
}



// **************** follow-up routines

void CFar_frr_evaluation2Dlg::WriteSummaryFile(char *message)
{
	long i;
	// writes the .sum file with current results
	// open the sum file
	if ( !sumfile.Open   ( szSumfilename, CFile::modeCreate | CFile::modeWrite, &reportException ))
	{
		sprintf( tmp, "!! Cannot open file %-12s", szSumfilename);
		Display_mess(tmp);
		return;
	}
	_strtime( tmpbuf1 );
    _strdate( tmpbuf2 );
	sprintf(tmp,"001 Far_frr_evaluation2 version         = %s\n",VERSION);				sumfile.WriteString(tmp);	
	sprintf(tmp,"002 Far_frr_evaluation2 compile date    = %s\n",COMPILE_DATE);			sumfile.WriteString(tmp);	
	sprintf(tmp,"010 BioEngine                           = %s\n",BIOENGINE_NAME);		sumfile.WriteString(tmp);	
	sprintf(tmp,"011 BioEngine release                   = %s\n",BIOENGINE_VERSION);	sumfile.WriteString(tmp);	
	sprintf(tmp,"020 Execution date/time                 = %s %s\n",tmpbuf2,tmpbuf1);	sumfile.WriteString(tmp);
	sprintf(tmp,"030 Database  = %s\n",curdir);											sumfile.WriteString(tmp);
	sprintf(tmp,"031 Number of bitmap files              = %7i\n",lCbmp);				sumfile.WriteString(tmp);
	sprintf(tmp,"032 Number of fingers                   = %7i\n",lC001);				sumfile.WriteString(tmp);
	sprintf(tmp,"033 Number of FRR pairs                 = %7i\n",lTestFrr);			sumfile.WriteString(tmp);
	sprintf(tmp,"034 Number of FAR pairs                 = %7i\n",lTestFar);			sumfile.WriteString(tmp);
	long lCfrr2, lCfar2;
	for (i=0; i<THRS_STEP; i++)
	{
	}
	for (i=0; i<THRS_STEP; i++)
	{	sprintf(tmp,"%03i Threshold %2i                        = %7i\n",   400+i, i, lThrs[i]);					sumfile.WriteString(tmp);}
	for (i=0; i<THRS_STEP; i++)
	{	sprintf(tmp,"%03i Number of FRR pairs at threshold %2i = %7i\n",   500+i, i, lCfrr[i]);					sumfile.WriteString(tmp);}
	for (i=0; i<THRS_STEP; i++)
	{	sprintf(tmp,"%03i Number of FAR pairs at threshold %2i = %7i\n",   600+i, i, lCfar[i]);					sumfile.WriteString(tmp);}
	for (i=0; i<THRS_STEP; i++)
	{	
		lCfrr2 = lCfrr[i];
		if (!lCfrr2) lCfrr2 = 1; // to avoid zeros for logarithm and remember precision...
		sprintf(tmp,"%03i FRR                 at threshold %2i = %5.3f\n", 700+i, i, (double) lCfrr2/lTestFrr);	sumfile.WriteString(tmp);
	}
	for (i=0; i<THRS_STEP; i++)
	{			
		lCfar2 = lCfar[i];
		if (!lCfar2) lCfar2 = 1;
		sprintf(tmp,"%03i FAR                 at threshold %2i = %10.8f\n",800+i, i, (double) lCfar2/lTestFar);	sumfile.WriteString(tmp);
	}
	sprintf(tmp,"900 Time to extract minutia on one file = %7.5f s\n", dFrr);		sumfile.WriteString(tmp);
	sprintf(tmp,"901 Time to perform one match           = %7.5f s\n", dFar);		sumfile.WriteString(tmp);
	sprintf(tmp,"996 Database string = %s\n",m_database);							sumfile.WriteString(tmp);
	sprintf(tmp,"997 Bioengine company string = %s\n",m_bioengine_company);			sumfile.WriteString(tmp);
	sprintf(tmp,"998 Bioengine version string = %s\n",m_bioengine_version);			sumfile.WriteString(tmp);
	sprintf(tmp,"999 Status = %s\n",message);										sumfile.WriteString(tmp);
	sumfile.Close();
}

short CFar_frr_evaluation2Dlg::WatchDog(long total, long done)
{
	// start is the starting date
	// total is the total number to process
	// done is the number already done

	static time_t lastime;
	       time_t current;

	double dur_done, dur_remain;
	current = clock();
	dur_done = (current - lastime)/(double)CLOCKS_PER_SEC;

	if ( dur_done > 2.0 )
	{
		DrawFarFrr();
		lastime = current;
		// check if the user wants to break the test
		MSG msg;
		if (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE))	
		{
			switch (msg.message)
			{
			case WM_RBUTTONDOWN: 
			case WM_LBUTTONDOWN: if (WannaAbort()) return(1); 
			}
			TranslateMessage (&msg);
			DispatchMessage  (&msg);
		}
		// display the estimated remaining time to work
		dur_done   = (double)(current - start) / (double)CLOCKS_PER_SEC;
		dur_remain = (total - done) * dur_done/done;
		long remain = (long) dur_remain;
		sprintf(tmp,"RUN estimated remaining time %i' %02i\" for %i tests", remain/60, remain%60, total-done);
		Display_mess(tmp);
	}
	return(0);
}

short CFar_frr_evaluation2Dlg::WannaAbort()
{
	short status;
	WriteSummaryFile("Unfinished test");
	sprintf(tmp, "Do you want to resume the %s test? \n(if you cancel, you must restart from the beginning)", BIOENGINE_NAME);
	switch (MessageBox(tmp,"User break",MB_OKCANCEL | MB_APPLMODAL | MB_ICONEXCLAMATION))
	{
	case IDCANCEL:	Display_mess("Test aborted");
					logfile.Close();
					scofile.Close();
					// write summary file
					status=1;
					break;
	case IDOK:		status=0;
					break;
	}
	// write summary file
	return(status);
}


// *************** bitmap routines *****************

short CFar_frr_evaluation2Dlg::ReadBmp(char *bmp, unsigned char *pPixel, long *xsize, long *ysize)
{
	#define DIB_HEADER_MARKER   ((WORD) ('M' << 8) | 'B')
	CFile file;
	DWORD dwBitsSize;
	BITMAPFILEHEADER bmfHeader;
	int	padding,i;

	if ( !file.Open( bmp, CFile::modeRead , &fileException ))
	{
		sprintf( tmp, "!!Cannot open file: %s", bmp);
		Log_mess(tmp);
		return(1);
	};
	dwBitsSize = file.GetLength();
	if (    (file.Read((LPSTR)&bmfHeader, sizeof(bmfHeader)) !=  sizeof(bmfHeader)) 
		 || (bmfHeader.bfType != DIB_HEADER_MARKER))
	{
		sprintf( tmp, "!!file io error: %s", bmp);
		Log_mess(tmp);
		file.Close();
		return(2);
	};

	BITMAPINFOHEADER bmif;
	file.Read(&bmif,sizeof(BITMAPINFOHEADER)); // load BITMAPINFOHEADER
	file.Read(pPixel,bmfHeader.bfOffBits - sizeof(BITMAPINFOHEADER)- sizeof(BITMAPFILEHEADER)); // load remaining byte

	*xsize  = bmif.biWidth;   
	*ysize  = bmif.biHeight;

	unsigned long size = dwBitsSize - bmfHeader.bfOffBits + sizeof(BITMAPFILEHEADER) - sizeof(bmfHeader);

	if (size>=MAXPIXEL)
	{
		sprintf( tmp, "recompile, bitmap too large %s", bmp);
		Log_mess(tmp);
		file.Close();
		return(3);
	};

	padding = (bmif.biWidth*3)%4;

	// puis lecture du bmp !
	for(i=bmif.biHeight-1;i>=0;i--)
	{
		if( file.Read(pPixel+i*bmif.biWidth, bmif.biWidth) != bmif.biWidth) // modification pour toutes largeurs de bmp
		{
			sprintf( tmp, "file %-12s io error bad size", bmp);
			Log_mess(tmp);
			file.Close();
			return(4);
		};
		file.Seek(padding,CFile::current);
	}

	/*if (file.ReadHuge(pPixel, size) != size)
	{
		sprintf( tmp, "file %-12s io error bad size", bmp);
		Log_mess(tmp);
		file.Close();
		return(4);
	};*/

	file.Close();

	return(0);
}


void CFar_frr_evaluation2Dlg::Clip_image(unsigned char *imagin, long xsize, long ysize, 
										 unsigned char *imagou, long xout,  long yout   )
{
	// clip the incoming image into the output image
	// if yout is negative, the image is upside-down

	unsigned char  *pDst, *pSrc, *pd, *ps;
	long  x, xcopy, ycopy, xdest, ydest;

	if (!yout) return;

	xdest = xout;
	if (yout<0) ydest=-yout;
	else		ydest= yout;

	memset(imagou, 0, xdest*ydest ); // clear destination image

	// source pointer
	pSrc = imagin;

	// destination pointer
	if (yout<0)	pDst = imagou + xdest*(ydest-1); // last line of DIB
	else		pDst = imagou;					 // first line

	// number of line to copy
	if (ysize<ydest)	// small image to copy in large image
	{
		ycopy  = ysize; // all lines are copied, imagou is large
		if (yout<0)	pDst  -= ((ydest-ycopy)/2)*xdest; // skip some lines, backward
		else		pDst  += ((ydest-ycopy)/2)*xdest; // skip some lines, forward
	}
	else				// little image to clip
	{
		ycopy  = ydest;	// reconstructed image is greater than destination
		pSrc  += ((ycopy-ydest)/2)*xsize;
	}
	//we have ycopy lines to copy

	//size in x
	if (xsize<xdest)	// little image to copy in a large one
	{
		xcopy= xsize;
		pDst+= (xdest-xsize)>>1;
	}
	else				// cut the image in x
	{
		xcopy= xdest;
		pSrc+= (xsize-xdest)>>1;
	}
	//we have xcopy pixel to copy per line

	//copy
	if (yout<0) // upside down
	{
		while (ycopy--)
		{
			ps = pSrc; pd = pDst; x = xcopy;
			while (x--) *pd++ = *ps++;	
			pSrc +=  xsize;     //next source line
			pDst -=  xdest;		//previous resulting line
		}
	}
	else
	{
		while (ycopy--)
		{
			ps = pSrc; pd = pDst; x = xcopy;
			while (x--) *pd++ = *ps++;	
			pSrc +=  xsize;     //next source line
			pDst +=  xdest;		//next resulting line
		}
	}

	return;
}

// ************* Drawing routines

void CFar_frr_evaluation2Dlg::DrawFarFrr()
{
	#define X0     30
	#define Y0     20
	#define XPICT 280	// size of display
	#define YPICT 140
	// clear screen
	pDC->FillSolidRect( 0, 0, XPICT+X0, YPICT+Y0, RGB(255, 255, 255) );
	// draw axes
	pDC->SelectObject(hpen0);
	long i;
	#define XAXE 14	// verticals
	for (i=1; i<XAXE; i++)
	{
		pDC->MoveTo( X0 + i*XPICT/XAXE, YPICT );
		pDC->LineTo( X0 + i*XPICT/XAXE, -1    );
		sprintf(tmp,"%2i",i*5);
		if (!(i%2))
			pDC->TextOut( X0+i*XPICT/XAXE-7, YPICT+3, tmp );
	}
	#define YAXE 7
	for (i=1; i<YAXE; i++)
	{
		pDC->MoveTo( X0,       i*YPICT/YAXE );
		pDC->LineTo( X0+XPICT, i*YPICT/YAXE );
		sprintf(tmp,"%2i",-i);
		pDC->TextOut( 13, i*YPICT/YAXE-8, tmp );
	}
	pDC->SelectObject(hpen2);
	pDC->MoveTo( 0       , YPICT    );
	pDC->LineTo( X0+XPICT, YPICT    );
	pDC->MoveTo( X0,       YPICT+Y0-1);
	pDC->LineTo( X0,       -1       );
	// draw the text
	pDC->TextOut( X0+XPICT-50, YPICT+3, "% FRR" );
	pDC->TextOut( 2, 0, "FAR" );
	// draw the curve
	// compute the point
	pDC->SelectObject(hpen1);
	POINT FarFrr[THRS_STEP];
	if (lTestFrr && lTestFar)
	{
		for (i=0; i<THRS_STEP; i++)
		{
			long lCfrr2 = lCfrr[i];
			long lCfar2 = lCfar[i];
			if (!lCfrr2) lCfrr2 = 1; // to avoid zeros for logarithm and remember precision...
			if (!lCfar2) lCfar2 = 1;
			double x,y;
			x = 100.0*lCfrr2/lTestFrr; // in %
			y = log10(1.0*lCfar2/lTestFar);
			FarFrr[i].x = (long) (X0 - 1 + (x/5)*(XPICT/XAXE));
			FarFrr[i].y = (long) (-y*YPICT/YAXE);
			if (FarFrr[i].x>=XPICT+X0-1) FarFrr[i].x=XPICT+X0-1;
			if (FarFrr[i].y>=YPICT     ) FarFrr[i].y=YPICT;
			if (FarFrr[i].x<=X0)         FarFrr[i].x=X0;
			if (FarFrr[i].y<=0 )         FarFrr[i].y=0;
		}
		pDC->Polyline( FarFrr, 10 );
	}
	m_nfrr=lTestFrr;
	m_nfar=lTestFar;
	UpdateData(FALSE);
}


void CFar_frr_evaluation2Dlg::OnReadsum() 
{
	UpdateData(TRUE);
	// read the summary file to display results
	static char szFilter[] = "Select a summary file |*.sum||";
	CFileDialog selectfile(TRUE,"","far_frr_evaluation2.sum",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NONETWORKBUTTON,
		szFilter,NULL);
	selectfile.DoModal();
	szSumfilename=selectfile.GetPathName();

	// open the file for reading
	if ( !sumfile.Open   ( szSumfilename, CFile::modeRead, &reportException ))
	{
		sprintf( tmp, "!! Cannot open file %-12s", szSumfilename);
		Display_mess(tmp);
		return;
	}

	char readline[256], valline[256], errline[256];
	short conditionNumber;
	short line=0;

	while (sumfile.ReadString(readline,255))
	{
		line++;
		conditionNumber = Decode_condition(readline,valline,errline);
		if (conditionNumber > 0)
		{
			// load some selected values
				 if	(conditionNumber== 33) lTestFrr			   = atoi(valline);
			else if	(conditionNumber== 34) lTestFar			   = atoi(valline);
			else if	(conditionNumber==996) m_database		   = valline;
			else if	(conditionNumber==997) m_bioengine_company = valline;
			else if	(conditionNumber==998) m_bioengine_version = valline;
			else if (conditionNumber>=400 && conditionNumber<=400+THRS_STEP) lThrs[conditionNumber-400]=atoi(valline);
			else if (conditionNumber>=500 && conditionNumber<=500+THRS_STEP) lCfrr[conditionNumber-500]=atoi(valline);
			else if (conditionNumber>=600 && conditionNumber<=600+THRS_STEP) lCfar[conditionNumber-600]=atoi(valline);
		} // end condition OK
	}// no more lines
	sumfile.Close(); // terminated
	DrawFarFrr();
}

short CFar_frr_evaluation2Dlg::Decode_condition(char *inputline, char *valine, char *errline)
{
	// inputline is the raw input line (e.g. read from the file)
	// return the condition number
	//	  0 is a dummy line
	//	 -1 is a line that is not recognized
	//	 -2 is a line that has no value
	//	 -3 is a non valid line
	// return in valine the value
	// return in errline a comment about the error 

	// line must begin with 000, no blank.
	char cc;
	char *pLine;
	short condnumber;

	strcpy(errline,"");
	// eliminates beginning non-valid character
	pLine=inputline;
	while (cc=*pLine)
	{
		if (      ( cc>='0'  &&  cc<='9' )
			   || ( cc>='A'  &&  cc<='Z' )
			   || ( cc>='a'  &&  cc<='z' )
			   || ( cc=='_'  ||  cc=='-' )
		   ) // we have a valid character
		   break;
		pLine++;
	}
	if (!*pLine) // nothing 
	{
		strcpy(errline,"empty ");
		return(0);
	}

	// check if it is a valid number or if we ignore it
	condnumber = atoi(pLine);

	if (    (condnumber>=  1 && condnumber<= 34)
		 || (condnumber>=400 && condnumber<=400+THRS_STEP)
		 || (condnumber>=500 && condnumber<=500+THRS_STEP)
		 || (condnumber>=600 && condnumber<=600+THRS_STEP)
		 || (condnumber>=700 && condnumber<=700+THRS_STEP)
		 || (condnumber>=800 && condnumber<=800+THRS_STEP)
		 || (condnumber>=900 && condnumber<=999)
	   )
	{
		// find the "=" and the value
		pLine = strstr(pLine, "=");
		if (!pLine)
		{
			strcpy(errline,"missing = sign");
			return(-1);
		}
		pLine++;
		// find the next valid character
		while (cc=*pLine)
		{
			if (      ( cc>='0'  &&  cc<='9' )
				   || ( cc>='A'  &&  cc<='Z' )
				   || ( cc>='a'  &&  cc<='z' )
				   || ( cc=='_'  ||  cc=='-' )
				   || ( cc==')'  ||  cc=='(' )
			   ) // we have a valid character
			   break;
			pLine++;
		}
		if (!*pLine) // nothing more!
		{
			strcpy(errline,"missing value ");
			return(-2);
		}
		strcpy(valine,pLine);
		// eliminates trailing non-valid characters
		while (strlen(valine)>0)
		{
			cc=valine[strlen(valine)-1];
			if (      ( cc>='0'  &&  cc<='9' )
				   || ( cc>='A'  &&  cc<='Z' )
				   || ( cc>='a'  &&  cc<='z' )
				   || ( cc=='_'  ||  cc=='-' )
			   ) // we have a valid character
			   break;
			valine[strlen(valine)-1]=0;
		}
		return(condnumber);
	}

	strcpy(errline, "not valid     ");
	return(-3);
}


// ****************** main routines **********************

void CFar_frr_evaluation2Dlg::OnSelect() 
{
	long i,j;
	UpdateData(TRUE);

	// select the directory where the database is
	static char szFilter[] = "Select a directory |*.log||";
	CFileDialog selectfile(TRUE,"","far_frr_evaluation2.log",
		OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT | OFN_NONETWORKBUTTON,
		szFilter,NULL);
	selectfile.DoModal();

	_getcwd(curdir, _MAX_PATH);		
	_splitpath( curdir, drive1, dir1, fname1, ext1 );
	m_database = curdir;

	// define filenames
	char base[_MAX_PATH];
	sprintf(tmp, "far_frr_evaluation2_%s_v%s_%s", BIOENGINE_NAME, BIOENGINE_VERSION, fname1);
	_makepath (base, drive1, dir1, tmp, "log");
	szLogfilename=base;
	_makepath (base, drive1, dir1, tmp, "sum");
	szSumfilename=base;
	_makepath (base, drive1, dir1, tmp, "sco");
	szScofilename=base;

	// open log files for far and frr reporting
	_makepath (base, drive1, dir1, tmp, "far");
	farFile.Open(base,CFile::modeWrite|CFile::modeCreate);
	_makepath (base, drive1, dir1, tmp, "frr");
	frrFile.Open(base,CFile::modeWrite|CFile::modeCreate);
	
	sprintf(tmp,"Log file will be: %s", szLogfilename);	Display_mess(tmp);
	sprintf(tmp,"Sum file will be: %s", szSumfilename);	Display_mess(tmp);
	sprintf(tmp,"Max number of bitmap : %i", MAXBITMAP);	Display_mess(tmp);
	sprintf(tmp,"Requested memory size: (about) %i bytes", 
		sizeof(bmp)+ sizeof(signature_first) + sizeof(signature_finger) + sizeof(bmpsorted) );	Display_mess(tmp);

	// count the number of files, and store the names
	lCbmp=0;
    if( (hFile1 = _findfirst( "*", &c_file1 )) != -1L )
	{
		do
		{
			if (c_file1.attrib==_A_SUBDIR && strcmp(c_file1.name,".."))
			{
				sprintf(fname2,"%s\\*.bmp",c_file1.name);
			    if( (hFile2 = _findfirst( fname2, &c_file2 )) != -1L )
				{
					do
					{
						sprintf(bmp[lCbmp].name,"%s\\%s",c_file1.name, c_file2.name);
						lCbmp++;
						if (lCbmp>=MAXBITMAP)
						{
							Display_mess("!!! too much bitmaps, application must be recompiled !!!");
							return;
						}
					}
					while( _findnext( hFile2, &c_file2 ) == 0 );
					_findclose( hFile2 );
				}
			}
		} 
		while( _findnext( hFile1, &c_file1 ) == 0 );
		_findclose( hFile1 );
	};
	sprintf(tmp,"the directory and subdir contains %i .bmp files",lCbmp);
	Display_mess(tmp);
	sprintf(tmp,"%i bitmaps in %s",lCbmp,curdir);
	m_database = tmp;

	// sort the files
	Display_mess("Sorting bmp files...");
	bmpsorted[lCbmp]=lCbmp; // to stop the search
	for (i=0; i<lCbmp; i++)
	{
		long pos;
		// search the position where to store the file number i
		for (pos=0; pos<i; pos++)
			if (strcmp(bmp[i].name,bmp[bmpsorted[pos]].name)<0)
				break;
		// the info will be placed at position pos: we must move all the data after the pos+1
		if (pos<i)
			for (j=i; j>pos; j--)
				bmpsorted[j]=bmpsorted[j-1];
		// store the position
		bmpsorted[pos]=i;
	}
	Display_mess("... sorting files terminated.");

	// compute the number of tests
	lC001=0;
	lFrr=0;
	long local=0;
	for (i=0; i<lCbmp; i++)
	{
		local++;
		_splitpath( bmp[bmpsorted[i  ]].name, drive1, dir1, fname1, ext1 );
		_splitpath( bmp[bmpsorted[i+1]].name, drive2, dir2, fname2, ext2 );
		if (strcmp(dir1,dir2)) // next finger is a new finger
		{
			lC001++;
			lFrr += local*(local-1)/2;
			local=0;
		}
	}
	if( !m_fvcMode )
		lFar  = (lC001-1)*(lCbmp-lC001) + lC001*(lC001-1)/2;
	else
		lFar  = lC001*(lC001-1)/2;
	if (m_samplefar) lFar /= SAMPLEFAR;
	sprintf(tmp,"Number of bitmap files: %7i",lCbmp);	Display_mess(tmp);
	sprintf(tmp,"Number of first files : %7i",lC001);	Display_mess(tmp);
	sprintf(tmp,"Number of FRR pairs   : %7i",lFrr);	Display_mess(tmp);
	sprintf(tmp,"Number of FAR pairs   : %7i",lFar);	
	if (m_samplefar) strcat(tmp," (estimated, sampling FAR, not a full test)");
	Display_mess(tmp);

	if (lC001>=MAXFINGER)
	{
		Display_mess("!!! too much fingers, application must be recompiled !!!");
		return;
	}

	if (lFrr+lFar)
	{
		Display_mess("Click Run to start the computation");
		selected = 1;
	}
	else
	{
		Display_mess("Select a database!");
		selected =0;
	}

	if( loadParameters() )
		Display_mess("Error loading config file or no config file");
	else
		Display_mess("Config File loaded");
	
}


void CFar_frr_evaluation2Dlg::OnRun() 
{
	long i,j,k;
	UpdateData(TRUE);

	if (!selected)
	{
		Display_mess("Select a database first!");
		return;
	}
	// open the log file
	if ( !logfile.Open   ( szLogfilename, CFile::modeCreate | CFile::modeWrite, &reportException ))
	{
		sprintf( tmp, "!! Cannot open file %-12s", szLogfilename);
		Display_mess(tmp);
		return;
	}

	// open the score file
	if ( !scofile.Open   ( szScofilename, CFile::modeCreate | CFile::modeWrite, &reportException ))
	{
		sprintf( tmp, "!! Cannot open file %-12s", szScofilename);
		Display_mess(tmp);
		return;
	}
	_strtime( tmpbuf1 );
    _strdate( tmpbuf2 );
	sprintf(tmp,"001 Far_frr_evaluation2 version         = %s\n",VERSION);				scofile.WriteString(tmp);	
	sprintf(tmp,"002 Far_frr_evaluation2 compile date    = %s\n",COMPILE_DATE);			scofile.WriteString(tmp);	
	sprintf(tmp,"010 BioEngine                           = %s\n",BIOENGINE_NAME);		scofile.WriteString(tmp);	
	sprintf(tmp,"011 BioEngine release                   = %s\n",BIOENGINE_VERSION);	scofile.WriteString(tmp);	
	sprintf(tmp,"020 Execution date/time                 = %s %s\n",tmpbuf2,tmpbuf1);	scofile.WriteString(tmp);
	sprintf(tmp,"030 Database  = %s\n",curdir);											scofile.WriteString(tmp);
	sprintf(tmp,"031 Number of bitmap files              = %7i\n",lCbmp);				scofile.WriteString(tmp);
	sprintf(tmp,"032 Number of fingers                   = %7i\n",lC001);				scofile.WriteString(tmp);
	sprintf(tmp,"996 Database string = %s\n",m_database);								scofile.WriteString(tmp);
	sprintf(tmp,"997 Bioengine company string = %s\n",m_bioengine_company);				scofile.WriteString(tmp);
	sprintf(tmp,"998 Bioengine version string = %s\n",m_bioengine_version);				scofile.WriteString(tmp);

	DrawFarFrr();

	sprintf(tmp,"Far_frr_evaluation2 version %s dated %s",VERSION,COMPILE_DATE);	Log_mess(tmp);
	sprintf(tmp,"BioEngine: %s release %s",BIOENGINE_NAME, BIOENGINE_VERSION);		Log_mess(tmp);
	sprintf(tmp,"Database : %s", curdir);											Log_mess(tmp);
	_strtime( tmpbuf1 );
    _strdate( tmpbuf2 );
	sprintf(tmp,"Start time: %s %s",tmpbuf2,tmpbuf1);								Log_mess(tmp);
	sprintf(tmp,"Number of bitmap files: %7i",lCbmp);	Log_mess(tmp);
	sprintf(tmp,"Number of first files : %7i",lC001);	Log_mess(tmp);
	sprintf(tmp,"Number of FRR pairs   : %7i",lFrr);	Log_mess(tmp);
	sprintf(tmp,"Number of FAR pairs   : %7i",lFar);
	if (m_samplefar) strcat(tmp," (estimated, as FAR sampling requested)");
	Log_mess(tmp);
	sprintf(tmp,"BioEngine Speed=%d\n",m_speed.GetCurSel());								Log_mess(tmp);

	// define threshold
	lThrs[0]= BIOENGINE_THRESHOLD_0; 
	lThrs[1]= BIOENGINE_THRESHOLD_1; 
	lThrs[2]= BIOENGINE_THRESHOLD_2; 
	lThrs[3]= BIOENGINE_THRESHOLD_3; 
	lThrs[4]= BIOENGINE_THRESHOLD_4; 
	lThrs[5]= BIOENGINE_THRESHOLD_5; 
	lThrs[6]= BIOENGINE_THRESHOLD_6; 
	lThrs[7]= BIOENGINE_THRESHOLD_7; 
	lThrs[8]= BIOENGINE_THRESHOLD_8; 
	lThrs[9]= BIOENGINE_THRESHOLD_9; 
	lTFAR   = BIOENGINE_THRESHOLD_FAR; 
	lTFRR   = BIOENGINE_THRESHOLD_FRR ;
	// scoring levels
	thlevel[0]= BIOENGINE_THRESHOLD_FAR3;
	thlevel[1]= BIOENGINE_THRESHOLD_FAR4;
	thlevel[2]= BIOENGINE_THRESHOLD_FAR5;
	// initialize the counts
	memset(lCfar,0,sizeof(lCfar));
	memset(lCfrr,0,sizeof(lCfrr));
	memset(lCfarScore,0,sizeof(lCfarScore));
	sprintf(tmp,"Thresholds:");	
	for (i=0; i<THRS_STEP; i++)
		sprintf(tmp,"%s %i", tmp, lThrs[i]);	
	Log_mess(tmp);
	sprintf(tmp,"Threshold to report FRR pairs: %5i",lTFRR);	Log_mess(tmp);
	sprintf(tmp,"Threshold to report FAR pairs: %5i",lTFAR);	Log_mess(tmp);

	// estimate the time to read the bitmaps
	Log_mess("Estimate time to read the bitmap files...");
	char lastdir[_MAX_DIR];
	strcpy(lastdir,"");
	long lC001r=0;
	start = clock();
	for (i=0; i<lCbmp; i++)
	{
		_splitpath( bmp[bmpsorted[i]].name , drive1, dir1, fname1, ext1 );
		if (i==0 || strcmp(dir1,lastdir)) // new finger
		{
			unsigned char pixels[MAXPIXEL];
			if(ReadBmp(bmp[bmpsorted[i]].name, pixels, &bmp[bmpsorted[i]].xsize, &bmp[bmpsorted[i]].ysize))
			{
				logfile.Close();
				return;
			}
			lC001r++;
			strcpy(lastdir,dir1); // next finger
		}
		if (WatchDog(lC001, lC001r)) return;
	}
	finish = clock();
	dBmp = (finish - start) / (double)CLOCKS_PER_SEC; // time to extract lC001 files
	dBmp = dBmp/lC001r;
	sprintf(tmp,"Time read one bitmap: %7.5f s (not very accurate, depends on memory, hard drive...)", dBmp);	Log_mess(tmp);
	Log_mess("... read test terminated");

	// extract signature from the first file of each directory
	Log_mess("Extract signature of first file of each directory...");
	strcpy(lastdir,"");
	lC001r=0;
	start = clock();
	for (i=0; i<lCbmp; i++)
	{
		_splitpath( bmp[bmpsorted[i]].name , drive1, dir1, fname1, ext1 );
		if (i==0 || strcmp(dir1,lastdir)) // new finger
		{
			if(Extract(bmpsorted[i], 1, lC001r)) // extract in signature_first 
			{
				logfile.Close();
				return;
			}
			bmp[bmpsorted[i]].first  = 1;		// it is a first file of finger
			bmp[bmpsorted[i]].idsign = lC001r;  // position of the minutiae
			lC001r++;
			strcpy(lastdir,dir1); // next finger
		}
		else
		{
			bmp[bmpsorted[i]].first = 0; // not extracted yet
		}
		if (WatchDog(lC001, lC001r)) return;
	}
	finish = clock();
	_strtime( tmpbuf1 );
    _strdate( tmpbuf2 );
	sprintf(tmp,"Time: %s %s",tmpbuf2,tmpbuf1);		Log_mess(tmp);
	dFrr1 = (finish - start) / (double)CLOCKS_PER_SEC; // time to extract lC001 files
	sprintf(tmp,"Time to extract %i minutiae        : %5.0f s", lC001r, dFrr1);	Log_mess(tmp);
	dFrr = dFrr1/lC001r - dBmp;
	sprintf(tmp,"Time to extract minutia on one file: %7.5f s", dFrr);	Log_mess(tmp);
	Log_mess("... extracting signature of first file terminated");

	// perform the test for each directory
	Log_mess("Compute Frr/Far...");
	lTest=0; lTestFar=0; lTestFrr=0;
	long lExtract=0;	// number of extracted finger 
	long lStart=0;		// this is the start of a new finger
	long lFirst=0;		// id of the first finger
	start = clock();
	for (i=0; i<lCbmp; i++)
	{
		if (bmp[bmpsorted[i]].first) // if it is the first image of a finger
		{
			if (lStart!=i)
				Log_mess("ERROR I got a problem detecting the first finger!");
			lFirst = bmpsorted[i]; // id of the first finger of the directory
			lExtract = 0;
			// we copy in the frr signature array for later check
			memcpy(signature_finger[lExtract].data, signature_first[bmp[lFirst].idsign].data, BIOENGINE_SIGNATURE_SIZE);
				   signature_finger[lExtract].id = lFirst;
			lExtract++;
			if( m_fvcMode && (!m_samplefar || (m_samplefar && (i%SAMPLEFAR == 1))))
				if(FarTest(bmpsorted[i])) return;
		}
		else // we extract the signature of the new file
		{
			if(Extract(bmpsorted[i], 2, lExtract)) // extract in signature_finger
			{
				logfile.Close();
				return;
			}
			bmp[bmpsorted[i]].first  = -1;			// it is not a first file
			bmp[bmpsorted[i]].idsign = lExtract;
			lExtract++; // one more extraction
		}
		
		// FAR test: against all the first
		// from 0 to lC001 (not included), excepted the same finger
		if ( !m_fvcMode && (!m_samplefar || (m_samplefar && (i%SAMPLEFAR == 1))))
			if(FarTest(bmpsorted[i])) return;

		// FRR test: the current matrix, if the directory is finished
		_splitpath( bmp[bmpsorted[i  ]].name, drive1, dir1, fname1, ext1 );
		_splitpath( bmp[bmpsorted[i+1]].name, drive2, dir2, fname2, ext2 );
		if (strcmp(dir1,dir2)) // next finger is a new finger
		{
			// from lStart to current number, excepted if only one finger
			if (lExtract>1)
			{
				if(FrrTest(lExtract)) return; // test the signature_finger in frr mode
			}
			lStart  = i + 1; // next finger is the first of the directory
		}
	}
	finish = clock();
	_strtime( tmpbuf1 );
    _strdate( tmpbuf2 );
	sprintf(tmp,"Time: %s %s",tmpbuf2,tmpbuf1);		Log_mess(tmp);
	dFar1 = (finish - start) / (double)CLOCKS_PER_SEC;
	sprintf(tmp,"Time to perform %i tests (%i): %5.0f s", lTest, lFrr+lFar, dFar1);	Log_mess(tmp);
	Log_mess("... computing Frr/Far terminated");

	dFar = (dFar1 - (lCbmp-lC001) * dFrr)/lTest;
	sprintf(tmp,"Number of bitmap files: %7i",lCbmp);								Log_mess(tmp);
	sprintf(tmp,"Number of first files : %7i",lC001);								Log_mess(tmp);
	sprintf(tmp,"Number of FRR pairs   : %7i",lTestFrr);							Log_mess(tmp);
	sprintf(tmp,"Number of FAR pairs   : %7i",lTestFar);							Log_mess(tmp);
	sprintf(tmp,"Threshold    FRR pairs         FAR pairs");						Log_mess(tmp);
	sprintf(tmp,"           %7i (%5.3f)  %7i (%10.8f)",lTestFrr,1.0,lTestFar,1.0);	Log_mess(tmp);
	double dCfar[THRS_STEP];
	for (i=0; i<THRS_STEP; i++)
	{
		long lCfrr2 = lCfrr[i];
		long lCfar2 = lCfar[i];
		if (!lCfrr2) lCfrr2 = 1; // to avoid zeros for logarithm and remember precision...
		if (!lCfar2) lCfar2 = 1;
		dCfar[i] = log10(1.0*lCfar2/lTestFar);
		sprintf(tmp,"T%i %5i   %7i (%5.3f)  %7i (%10.8f)",	i, lThrs[i], 
															lCfrr[i], (double) lCfrr2/lTestFrr,  
															lCfar[i], (double) lCfar2/lTestFar);
		Log_mess(tmp);	
	}
	sprintf(tmp,"Time to extract minutia on one file: %7.5f s", dFrr);				Log_mess(tmp);
	sprintf(tmp,"Time to perform one match          : %7.5f s", dFar);				Log_mess(tmp);


	// estimage the threshold to get a FAR of E-4
	for( k=1; k<=FAR10MOINS; k++ )
	{
		double estimated_threshold4 = -999;
		sprintf(tmp,"Estimate threshold for FAR==e-%d :",k);
		for (j=0; j<THRS_STEP; j++)
			if (dCfar[j]<=-k)
				break;
		if (j==0 || j==THRS_STEP)	strcat(tmp,"not possible"); 
		else // estimate the threshold
		{
			estimated_threshold4 = lThrs[j-1] + 1.0*(lThrs[j]-lThrs[j-1])*(-k - dCfar[j-1])/(dCfar[j]-dCfar[j-1]);
			sprintf(tmp,"%s %f", tmp, estimated_threshold4);
		}
		Log_mess(tmp);	
		sprintf(tmp,"FRR to get             FAR==e-%d :",k);
		if (estimated_threshold4<0) strcat(tmp,"not possible");
		else
		{
			// estimates number of pairs for the estimated threshold
			double rth= (double) ((estimated_threshold4 - lThrs[j-1]) / (lThrs[j]-lThrs[j-1]));
			rth *= (lCfrr[j]-lCfrr[j-1]);
			rth += lCfrr[j-1];
			rth /= lTestFrr;
			sprintf(tmp,"%s %f", tmp, rth);
		}
		Log_mess(tmp);
	}

	// write the summary file
	if (m_samplefar) WriteSummaryFile("Normal termination, short far test");
	else			 WriteSummaryFile("Normal termination");

	// end of program
	_strtime( tmpbuf1 );
    _strdate( tmpbuf2 );
	sprintf(tmp,"Stop time: %s %s",tmpbuf2,tmpbuf1);
	Log_mess(tmp);
	// close the log file
	logfile.Close();
	// terminates the score file
	sprintf(tmp,"040 Number of FRR pairs   : %7i\n",lTestFrr);	scofile.WriteString(tmp);
	sprintf(tmp,"041 Number of FAR pairs   : %7i",lTestFar);	
	if (m_samplefar) strcat(tmp, "(not a full far test)");
	strcat(tmp,"\n");	scofile.WriteString(tmp);
	for (i=0; i<THFAR; i++)
	{	
		sprintf(tmp,"%03i Threshold %2i                        = %7i\n",   50+i, i+3, thlevel[i]);
		scofile.WriteString(tmp);
		sprintf(tmp,"%03i Number of FAR pairs at threshold %2i = %7i\n",   60+i, i+3, lCfar[i]);
		scofile.WriteString(tmp);
		long lCfar2 = lCfarScore[i];
		if (!lCfar2) lCfar2 = 1;
		sprintf(tmp,"%03i FAR                 at threshold %2i = %10.8f\n",70+i, i+3, (double) lCfar2/lTestFar);
		scofile.WriteString(tmp);
		// estimage the threshold to get a FAR of 10-(i+3)
		for (j=0; j<THRS_STEP; j++)
			if (dCfar[j]<=-(i+3))
				break;
		if (j==0 || j==THRS_STEP)	sprintf(tmp,"%03i Estimate threshold for 10-%1i = not possible\n", 80+i, i+3);
		else // estimate the threshold
		{
			double estimated_threshold = lThrs[j-1] + 1.0*(lThrs[j]-lThrs[j-1])*(-(i+3)-dCfar[j-1])/(dCfar[j]-dCfar[j-1]);
			sprintf(tmp,"%03i Estimated threshold for 10-%i = %f\n", 80+i, i+3, estimated_threshold);
		}
		scofile.WriteString(tmp);
	}

	scofile.Close();
	farFile.Close();
	frrFile.Close();
	DrawFarFrr();
	selected=0;
}


// ************* Extract and compare routines are in Extract_far_frr.cpp
// most of the time, it is not needed to change these functions, but some
// bioengine requires to modify them (those which have no direct compare routines)

#include "Extract_far_frr.cpp"

// called in extract_far_frr / FrrTest()

void CFar_frr_evaluation2Dlg::FrrTestScoring(long num)
{
	long i,j;
	// compute the scoring values to output in the .sco file
	for (i=0; i<num; i++) // for each file
	{
		sprintf(tmp,"100 %s N=%3i", bmp[signature_finger[i].id].name, num);
		short numok;
		for (j=0; j<THFAR; j++)
		{
			numok=0;
			long k;
			// compute the scoring for this threshold
			for (k=0; k<num; k++)
			{
				if (k>i && lscore[i][k]>=thlevel[j]) numok++; //24-JAN-2002: above or equal!
				if (k<i && lscore[k][i]>=thlevel[j]) numok++;
			}
			sprintf(tmp,"%s T%1i=%3i ",tmp,j+3,numok);
		}
		// 24-JAN-2002: add if it has matched with image 001 and the last @10-4
		numok=1;
		if (i>0 && lscore[0][i]<thlevel[1])
			numok=0;
		sprintf(tmp,"%s M4_001=%3i ",tmp, numok );
		numok=1;
		if (i!=num-1 && lscore[i][num-1]<thlevel[1])
			numok=0;
		sprintf(tmp,"%s M4_lst=%3i ",tmp, numok );
		strcat(tmp,"\n");
		scofile.WriteString(tmp);// write to file
	}
}
void CFar_frr_evaluation2Dlg::OnReadbin() 
{
	if( IsDlgButtonChecked( IDC_READBIN ) )
		g_readBin = true;
	else
		g_readBin = false;
	
}

void CFar_frr_evaluation2Dlg::OnSelchangeSpeed() 
{
	UpdateData(true);
	dpSetSpeed(0,m_speed.GetCurSel());
}
