// paramEditorDlg.cpp : implementation file
//

#include "stdafx.h"
#include "customTypes.h"
#include "staticParameters.h"
#include "dynamicParameters.h"
#include "errorCodes.h"
#include "exported.h"
#include "paramEditor.h"
#include "paramEditorDlg.h"

BioEngineParams	g_params;

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParamEditorDlg dialog

CParamEditorDlg::CParamEditorDlg(CWnd* pParent )
	: CDialog(CParamEditorDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CParamEditorDlg)
	m_maxNumberOfDetectedMinutiae = 0;
	m_maxNumberOfMinutiae = 0;
	m_maxNumberOfLocalInfos = 0;
	m_maxNumberOfCores = 0;
	m_normalizationMean = 0;
	m_normalizationStdDev = 0;
	m_qualityThreshold = 0;
	m_freqQualThreshold = 0.0f;
	m_freqQualThresholdInc = 0.0f;
	m_spectrumMultFactor = 0.0f;
	m_gaborWidth = 0.0f;
	m_gaborFreqMult = 0.0f;
	m_gaborFusionThreshold = 0.0f;
	m_nbClassesSegmentation = 0;
	m_nbClassesRejectSegmentation = 0;
	m_segmMedianFilterSize = 0;
	m_regionPerimeterCoef = 0;
	m_regionSurfaceCoef = 0;
	m_oriFusionMedianSize = 0;
	m_nbPtsFusionThreshold = 0;
	m_multFactorRegionFusion = 0.0f;
	m_fusionErodeSize = 0;
	m_finalFusionMedianSize = 0;
	m_fusionIntensityMultFactor = 0.0f;
	m_binaryMedianSize = 0;
	m_minimumCurvatureThreshold = 0;
	m_localInfosBlocSize = 0;
	m_minutiaeNeiborhoodSize = 0;
	m_branchMinSize = 0;
	m_maxReconnectSize = 0;
	m_minReconnectionAngle = 0;
	m_maxSupprAngle = 0;
	m_poincareSize = 0;
	m_maxRegistrationAngle = 0;
	m_firstPassAngleStep = 0;
	m_registerTranslationTolerance = 0;
	m_translation = 0;
	m_translationShift = 0;
	m_maxTranslationWidthShift1 = 0;
	m_maxTranslationWidthShift2 = 0;
	m_maxTranslationWidth2 = 0;
	m_maxTranslationWidth1 = 0;
	m_accuFill = 0;
	m_translationMaxThreshold = 0.0f;
	m_angleTolerance = 0;
	m_translationTolerance = 0;
	m_splineStiffness = 0.0f;
	m_minNumberOfMinutiae = 0;
	m_oriMatchNormalize = 0.0f;
	m_maxScore = 0;
	m_scoreNormalize = 0.0f;
	m_powFftFlag = FALSE;
	m_maxDeformation = 0;
	m_freqPos1 = 0;
	m_freqPos10 = 0;
	m_freqPos2 = 0;
	m_freqPos3 = 0;
	m_freqPos4 = 0;
	m_freqPos5 = 0;
	m_freqPos6 = 0;
	m_freqPos7 = 0;
	m_freqPos8 = 0;
	m_freqPos9 = 0;
	m_nbFreqPos = 0;
	m_regionDivCoef = 0.0f;
	m_distFindCoreAngle = 0;
	m_distDivCoef = 0.0f;
	m_minutiaeBoost = FALSE;
	m_defaultSecurity = 0;
	m_secuThreshold0 = 0;
	m_secuThreshold1 = 0;
	m_secuThreshold2 = 0;
	m_secuThreshold3 = 0;
	m_secuThreshold4 = 0;
	m_secuThreshold5 = 0;
	m_maxDbSearch = 0;
	m_secuThreshold6 = 0;
	m_max_img_width = 0;
	m_max_img_height = 0;
	m_globalImgScaling = 0;
	m_globalTemplateScaling = 0;
	m_fftBlocOverlap = 0;
	m_numOfOrientation = 0;
	m_oriStepSize = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CParamEditorDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CParamEditorDlg)
	DDX_Text(pDX, IDC_MAX_NUMBER_OF_DETECTED_MINUTIAE, m_maxNumberOfDetectedMinutiae);
	DDX_Text(pDX, IDC_MAX_NUMBER_OF_MINUTIAE, m_maxNumberOfMinutiae);
	DDX_Text(pDX, IDC_MAX_NUMBER_OF_LOCAL_INFOS, m_maxNumberOfLocalInfos);
	DDX_Text(pDX, IDC_MAX_NUMBER_OF_CORES, m_maxNumberOfCores);
	DDX_Text(pDX, IDC_NORMALIZATION_MEAN, m_normalizationMean);
	DDX_Text(pDX, IDC_NORMALISATION_STD_DEV, m_normalizationStdDev);
	DDX_Text(pDX, IDC_QUALITY_THRESHOLD, m_qualityThreshold);
	DDX_Text(pDX, IDC_FREQ_QUAL_THRESHOLD, m_freqQualThreshold);
	DDX_Text(pDX, IDC_FREQ_QUAL_THRESHOLD_INC, m_freqQualThresholdInc);
	DDX_Text(pDX, IDC_SPECTRUM_MULT_FACTOR, m_spectrumMultFactor);
	DDX_Text(pDX, IDC_GABOR_WIDTH, m_gaborWidth);
	DDX_Text(pDX, IDC_GABOR_FREQ_MULT, m_gaborFreqMult);
	DDX_Text(pDX, IDC_GABOR_FUSION_THRESHOLD, m_gaborFusionThreshold);
	DDX_Text(pDX, IDC_NB_CLASSES_SEGMENTATION, m_nbClassesSegmentation);
	DDX_Text(pDX, IDC_NB_CLASSES_REJECT_SEGMENTATION, m_nbClassesRejectSegmentation);
	DDX_Text(pDX, IDC_SEGM_MEDIAN_FILTER_SIZE, m_segmMedianFilterSize);
	DDX_Text(pDX, IDC_REGION_PERIMETER_COEF, m_regionPerimeterCoef);
	DDX_Text(pDX, IDC_REGION_SURFACE_COEF, m_regionSurfaceCoef);
	DDX_Text(pDX, IDC_ORI_FUSION_MEDIAN_SIZE, m_oriFusionMedianSize);
	DDX_Text(pDX, IDC_NB_PTS_FUSION_THRESHOLD, m_nbPtsFusionThreshold);
	DDX_Text(pDX, IDC_MULT_FACTOR_REGION_FUSION, m_multFactorRegionFusion);
	DDX_Text(pDX, IDC_FUSION_ERODE_SIZE, m_fusionErodeSize);
	DDX_Text(pDX, IDC_FINAL_FUSION_MEDIAN_SIZE, m_finalFusionMedianSize);
	DDX_Text(pDX, IDC_FUSION_INTENSITY_MULT_FACTOR, m_fusionIntensityMultFactor);
	DDX_Text(pDX, IDC_BINARY_MEDIAN_SIZE, m_binaryMedianSize);
	DDX_Text(pDX, IDC_MINIMUM_CURVATURE_THRESHOLD, m_minimumCurvatureThreshold);
	DDX_Text(pDX, IDC_LOCAL_INFOS_BLOC_SIZE, m_localInfosBlocSize);
	DDX_Text(pDX, IDC_MINUTIAE_NEIBORHOOD_SIZE, m_minutiaeNeiborhoodSize);
	DDX_Text(pDX, IDC_BRANCH_MIN_SIZE, m_branchMinSize);
	DDX_Text(pDX, IDC_MAX_RECONNECT_SIZE, m_maxReconnectSize);
	DDX_Text(pDX, IDC_MIN_RECONNECTION_ANGLE, m_minReconnectionAngle);
	DDX_Text(pDX, IDC_MAX_SUPPR_ANGLE, m_maxSupprAngle);
	DDX_Text(pDX, IDC_POINCARE_SIZE, m_poincareSize);
	DDX_Text(pDX, IDC_MAX_REGISTRATION_ANGLE, m_maxRegistrationAngle);
	DDX_Text(pDX, IDC_FIRST_PASS_ANGLE_STEP, m_firstPassAngleStep);
	DDX_Text(pDX, IDC_REGISTER_TRANSLATION_TOLERANCE, m_registerTranslationTolerance);
	DDX_Text(pDX, IDC_TRANSLATION, m_translation);
	DDX_Text(pDX, IDC_TRANSLATION_SHIFT, m_translationShift);
	DDX_Text(pDX, IDC_MAX_TRANSLATION_WIDTH_SHIFT_1, m_maxTranslationWidthShift1);
	DDX_Text(pDX, IDC_MAX_TRANSLATION_WIDTH_SHIFT_2, m_maxTranslationWidthShift2);
	DDX_Text(pDX, IDC_MAX_TRANSLATION_WIDTH_2, m_maxTranslationWidth2);
	DDX_Text(pDX, IDC_MAX_TRANSLATION_WIDTH_1, m_maxTranslationWidth1);
	DDX_Text(pDX, IDC_ACCU_FILL, m_accuFill);
	DDX_Text(pDX, IDC_TRANSLATION_MAX_THRESHOLD, m_translationMaxThreshold);
	DDX_Text(pDX, IDC_ANGLE_TOLERANCE, m_angleTolerance);
	DDX_Text(pDX, IDC_TRANSLATION_TOLERANCE, m_translationTolerance);
	DDX_Text(pDX, IDC_SPLINE_STIFFNESS, m_splineStiffness);
	DDX_Text(pDX, IDC_MIN_NUMBER_OF_MINUTIAE, m_minNumberOfMinutiae);
	DDX_Text(pDX, IDC_ORI_MATCH_NORMALIZE, m_oriMatchNormalize);
	DDX_Text(pDX, IDC_MAX_SCORE, m_maxScore);
	DDX_Text(pDX, IDC_SCORE_NORMALIZE, m_scoreNormalize);
	DDX_Text(pDX, IDC_POW_FFT_FLAG, m_powFftFlag);
	DDX_Text(pDX, IDC_MAX_DEFORMATION, m_maxDeformation);
	DDX_Text(pDX, IDC_FREQ_POS_1, m_freqPos1);
	DDX_Text(pDX, IDC_FREQ_POS_10, m_freqPos10);
	DDX_Text(pDX, IDC_FREQ_POS_2, m_freqPos2);
	DDX_Text(pDX, IDC_FREQ_POS_3, m_freqPos3);
	DDX_Text(pDX, IDC_FREQ_POS_4, m_freqPos4);
	DDX_Text(pDX, IDC_FREQ_POS_5, m_freqPos5);
	DDX_Text(pDX, IDC_FREQ_POS_6, m_freqPos6);
	DDX_Text(pDX, IDC_FREQ_POS_7, m_freqPos7);
	DDX_Text(pDX, IDC_FREQ_POS_8, m_freqPos8);
	DDX_Text(pDX, IDC_FREQ_POS_9, m_freqPos9);
	DDX_Text(pDX, IDC_NB_FREQ_POS, m_nbFreqPos);
	DDX_Text(pDX, IDC_REGION_DIV_COEF, m_regionDivCoef);
	DDX_Text(pDX, IDC_DIST_FIND_CORE_ANGLE, m_distFindCoreAngle);
	DDX_Text(pDX, IDC_DIST_DIV_COEF, m_distDivCoef);
	DDX_Text(pDX, IDC_MINUTIAE_BOOST, m_minutiaeBoost);
	DDX_Text(pDX, IDC_DEFAULT_SECURITY, m_defaultSecurity);
	DDX_Text(pDX, IDC_MAX_DB_SEARCH, m_maxDbSearch);
	DDX_Text(pDX, IDC_MAX_IMG_WIDTH, m_max_img_width);
	DDX_Text(pDX, IDC_MAX_IMG_HEIGHT, m_max_img_height);
	DDX_Text(pDX, IDC_GLOBAL_IMG_SCALING, m_globalImgScaling);
	DDX_Text(pDX, IDC_GLOBAL_TEMPLATE_SCALING, m_globalTemplateScaling);
	DDX_Text(pDX, IDC_FFT_BLOC_OVERLAP, m_fftBlocOverlap);
	DDX_Text(pDX, IDC_NUM_OF_ORIENTATION, m_numOfOrientation);
	DDX_Text(pDX, IDC_ORI_STEP_SIZE, m_oriStepSize);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CParamEditorDlg, CDialog)
	//{{AFX_MSG_MAP(CParamEditorDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_LOAD, OnLoad)
	ON_BN_CLICKED(IDC_SAVE, OnSave)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CParamEditorDlg message handlers

BOOL CParamEditorDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// My inits

	dpInit();
		// set default parameters values 
	g_params.m_maxNumberOfDetectedMinutiae  = MAX_NUMBER_OF_DETECTED_MINUTAE;
	g_params.m_maxNumberOfMinutiae			= MAX_NUMBER_OF_MINUTIAE;
	g_params.m_maxNumberOfLocalInfos		= MAX_NUMBER_OF_LOCAL_INFOS;
	g_params.m_maxNumberOfCores				= MAX_NUMBER_OF_CORES;
	g_params.m_normalizationMean			= NORMALISATION_MEAN;
	g_params.m_normalizationStdDev			= NORMALISATION_STD_DEV;
	g_params.m_qualityThreshold				= QUALITY_THRESHOLD;
	g_params.m_freqQualThreshold			= FREQ_QUAL_THRESHOLD;
	g_params.m_freqQualThresholdInc			= FREQ_QUAL_THRESHOLD_INC;
	g_params.m_spectrumMultFactor			= SPECTRUM_MULT_FACTOR;
	g_params.m_gaborWidth					= GABOR_WIDTH;
	g_params.m_gaborFreqMult				= GABOR_FREQ_MULT;
	g_params.m_gaborFusionThreshold			= GABOR_FUSION_THRESHOLD;
	g_params.m_nbClassesSegmentation		= NB_CLASSES_SEGMENTATION;
	g_params.m_nbClassesRejectSegmentation	= NB_CLASSES_REJECT_SEGMENTATION;
	g_params.m_segmMedianFilterSize			= SEGM_MEDIAN_FILTER_SIZE;
	g_params.m_regionDivCoef				= REGION_DIV_COEF;
	g_params.m_regionPerimeterCoef			= REGION_PERIMETER_COEF;
	g_params.m_regionSurfaceCoef			= REGION_SURFACR_COEF;
	g_params.m_oriFusionMedianSize			= ORI_FUSION_MEDIAN_SIZE;
	g_params.m_nbPtsFusionThreshold			= NB_PTS_FUSION_THRESHOLD;
	g_params.m_multFactorRegionFusion		= MULT_FACTOR_REGION_FUSION;
	g_params.m_fusionErodeSize				= FUSION_ERODE_SIZE;
	g_params.m_finalFusionMedianSize		= FINAL_FUSION_MEDIAN_SIZE;
	g_params.m_fusionIntensityMultFactor	= FUSION_INTENSITY_MULT_FACTOR;
	g_params.m_binaryMedianSize				= BINARY_MEDIAN_SIZE;
	g_params.m_minimumCurvatureThreshold	= MINIMUM_CURVATURE_THRESHOLD;
	g_params.m_localInfosBlocSize			= LOCAL_INFOS_BLOC_SIZE;
	g_params.m_minutiaeNeiborhoodSize		= MINUTIAE_NEIBORHOOD_SIZE;
	g_params.m_branchMinSize				= BRANCH_MIN_SIZE;
	g_params.m_maxReconnectSize				= MAX_RECONNECT_SIZE;
	g_params.m_minReconnectionAngle			= MIN_RECONNECTION_ANGLE;
	g_params.m_maxSupprAngle				= MAX_SUPPR_ANGLE;
	g_params.m_poincareSize					= POINCARE_SIZE;
	g_params.m_maxRegistrationAngle			=MAX_REGISTRATION_ANGLE;
	g_params.m_fisrtPassAngleStep			=FIRST_PASS_ANGLE_STEP;
	g_params.m_registerTranslationTolerance	=REGISTER_TRANSLATION_TOLERANCE;
	g_params.m_translationShift				=TRANSLATION_SHIFT;
	g_params.m_translation					=TRANSLATION;
	g_params.m_maxTranslationWidthShift1	=MAX_TRANSLATION_WIDTH_SHIFT_1;
	g_params.m_maxTranslationWidth1			=MAX_TRANSLATION_WIDTH_1;
	g_params.m_maxTranslationWidthShift2	=MAX_TRANSLATION_WIDTH_SHIFT_2;
	g_params.m_maxTranslationWidth2			=MAX_TRANSLATION_WIDTH_2;
	g_params.m_accuFill						=ACCU_FILL;
	g_params.m_translationMaxThreshold		=TRANSLATION_MAX_THRESHOLD;
	g_params.m_angleTolerance				=ANGLE_TOLERANCE;
	g_params.m_translationTolerance			=TRANSLATION_TOLERANCE;
	g_params.m_splineStiffness				=SPLINE_STIFFNESS;
	g_params.m_minNumberOfMinutiae			=MIN_NUMBER_OF_MINUTIAE;
	g_params.m_oriMatchNormalize			=ORI_MATCH_NORMALIZE;
	g_params.m_maxScore						=MAX_SCORE;
	g_params.m_scoreNormalize				=SCORE_NORMALIZE;
	g_params.m_powFftFlag					=POW_FFT_FLAG;
	g_params.m_maxDeformation				=MAX_DEFORMATION;
	g_params.m_nbFreqPos					=NB_FREQ_POS;
	g_params.m_freqPos[0] = FREQ_POS1;
	g_params.m_freqPos[1] = FREQ_POS2;
	g_params.m_freqPos[2] = FREQ_POS3;
	g_params.m_freqPos[3] = FREQ_POS4;
	g_params.m_freqPos[4] = FREQ_POS5;
	g_params.m_freqPos[5] = FREQ_POS6;
	g_params.m_freqPos[6] = FREQ_POS7;
	g_params.m_freqPos[7] = FREQ_POS8;
	g_params.m_freqPos[8] = FREQ_POS9;
	g_params.m_freqPos[9] = FREQ_POS10;
	g_params.m_distFindCoreAngle			= DIST_FIND_CORE_ANGLE;
	g_params.m_distDivCoef					= DIV_DIST_COEF;
	g_params.m_minutiaeBoost				= MINUTIAE_BOOST;
	g_params.m_defaultSecurity = DEFAULT_SECURITY;
	g_params.m_maxDbSearch = MAX_DB_SEARCH;
	g_params.m_max_img_width = MAX_IMG_WIDTH;
	g_params.m_max_img_height = MAX_IMG_HEIGHT;
	g_params.m_globalImgScaling = GLOBAL_IMG_SCALING;
	g_params.m_globalTemplateScaling = GLOBAL_TEMPLATE_SCALING;
	g_params.m_fftBlocOverlap = FFT_BLOC_OVERLAP;
	g_params.m_numOfOrientation = NUM_OF_ORIENTATION;
	g_params.m_oriStepSize = ORI_STEP_SIZE;

	globalToInterface();
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CParamEditorDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CParamEditorDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CParamEditorDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CParamEditorDlg::OnLoad() 
{
	CFile			file;
	unsigned char	*buffer;
	unsigned int	size;
	CFileDialog		fileDialog(true,"cfg",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Configuration file (*.cfg); *.cfg||");

	if( fileDialog.DoModal() == IDOK )
	{
		if( file.Open(fileDialog.GetPathName(),CFile::modeRead) )
		{
			// load file
			file.Read(&size,sizeof(unsigned int));
			buffer = new unsigned char[size];

			file.SeekToBegin();
			file.Read(buffer,size);

			file.Close();

			// load parameters in global struct
			if( dpLoadParameters( buffer, size ) != ZEF_OK )
					AfxMessageBox("Error during parameters loading");

			// copy paramters to interface variables
			globalToInterface();

			//free memory
			delete[] buffer;
		}
	}	
	
}

void CParamEditorDlg::OnSave() 
{
	CFile			file;
	unsigned char	*buffer=NULL;
	unsigned int	size;
	CFileDialog		fileDialog(false,"cfg",NULL,OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT,"Configuration file (*.cfg); *.cfg||");

	if( fileDialog.DoModal() == IDOK )
	{
		if( file.Open(fileDialog.GetPathName(),CFile::modeWrite|CFile::modeCreate) )
		{
			// copy parameters from interface variables to global struct
			interfaceToGlobal();

			// get buffer size
			size = 0;
			saveParameters( buffer, &size );
			buffer = new unsigned char[size];

			// save parameters to buffer
			if( saveParameters( buffer, &size ) != ZEF_OK )
				AfxMessageBox("Error during parameters writing");

			// write to file
			file.Write(buffer,size);
			file.Close();

			//free memory
			delete[] buffer;
		}
	}	
	
}

void CParamEditorDlg::globalToInterface()
{
	m_maxNumberOfDetectedMinutiae = g_params.m_maxNumberOfDetectedMinutiae;
	m_maxNumberOfMinutiae = g_params.m_maxNumberOfMinutiae;
	m_maxNumberOfLocalInfos = g_params.m_maxNumberOfLocalInfos;
	m_maxNumberOfCores = g_params.m_maxNumberOfCores;
	m_normalizationMean = g_params.m_normalizationMean;
	m_normalizationStdDev = g_params.m_normalizationStdDev;
	m_qualityThreshold = g_params.m_qualityThreshold;
	m_freqQualThreshold = TOFLT(g_params.m_freqQualThreshold,Q15_16);
	m_freqQualThresholdInc = TOFLT(g_params.m_freqQualThresholdInc,Q15_16);
	m_spectrumMultFactor = TOFLT(g_params.m_spectrumMultFactor,Q15_16);
	m_gaborWidth = TOFLT(g_params.m_gaborWidth,Q15_16);
	m_gaborFreqMult = TOFLT(g_params.m_gaborFreqMult,Q15_16);
	m_gaborFusionThreshold = TOFLT(g_params.m_gaborFusionThreshold,Q15_16);
	m_regionDivCoef = TOFLT(g_params.m_regionDivCoef,Q15_16);
	m_nbClassesSegmentation = g_params.m_nbClassesSegmentation;
	m_nbClassesRejectSegmentation = g_params.m_nbClassesRejectSegmentation;
	m_segmMedianFilterSize = g_params.m_segmMedianFilterSize;
	m_regionPerimeterCoef = g_params.m_regionPerimeterCoef;
	m_regionSurfaceCoef = g_params.m_regionSurfaceCoef;
	m_oriFusionMedianSize = g_params.m_oriFusionMedianSize;
	m_nbPtsFusionThreshold = g_params.m_nbPtsFusionThreshold;
	m_multFactorRegionFusion = TOFLT(g_params.m_multFactorRegionFusion,Q15_16);
	m_fusionErodeSize = g_params.m_fusionErodeSize;
	m_finalFusionMedianSize = g_params.m_finalFusionMedianSize;
	m_fusionIntensityMultFactor = TOFLT(g_params.m_fusionIntensityMultFactor,Q15_16);
	m_binaryMedianSize = g_params.m_binaryMedianSize;
	m_minimumCurvatureThreshold = g_params.m_minimumCurvatureThreshold;
	m_localInfosBlocSize = g_params.m_localInfosBlocSize;
	m_minutiaeNeiborhoodSize = g_params.m_minutiaeNeiborhoodSize;
	m_branchMinSize = g_params.m_branchMinSize;
	m_maxReconnectSize = g_params.m_maxReconnectSize;
	m_minReconnectionAngle = g_params.m_minReconnectionAngle;
	m_maxSupprAngle = g_params.m_maxSupprAngle;
	m_poincareSize = g_params.m_poincareSize;
	m_maxRegistrationAngle = g_params.m_maxRegistrationAngle;
	m_firstPassAngleStep = g_params.m_fisrtPassAngleStep;
	m_registerTranslationTolerance = g_params.m_registerTranslationTolerance;
	m_translation = g_params.m_translation;
	m_translationShift = g_params.m_translationShift;
	m_maxTranslationWidthShift1 = g_params.m_maxTranslationWidthShift1;
	m_maxTranslationWidthShift2 = g_params.m_maxTranslationWidthShift2;
	m_maxTranslationWidth1 = g_params.m_maxTranslationWidth1;
	m_maxTranslationWidth2 = g_params.m_maxTranslationWidth2;
	m_accuFill = g_params.m_accuFill;
	m_translationMaxThreshold = TOFLT(g_params.m_translationMaxThreshold,Q15_16);
	m_angleTolerance = g_params.m_angleTolerance;
	m_translationTolerance = g_params.m_translationTolerance;
	m_splineStiffness = TOFLT(g_params.m_splineStiffness,Q15_16);
	m_minNumberOfMinutiae = g_params.m_minNumberOfMinutiae;
	m_oriMatchNormalize = TOFLT(g_params.m_oriMatchNormalize,Q15_16);
	m_maxScore = g_params.m_maxScore;
	m_scoreNormalize = TOFLT(g_params.m_scoreNormalize,Q15_16);
	m_powFftFlag = g_params.m_powFftFlag;
	m_maxDeformation = g_params.m_maxDeformation;
	m_freqPos1 = g_params.m_freqPos[0];
	m_freqPos10 = g_params.m_freqPos[9];
	m_freqPos2 = g_params.m_freqPos[1];
	m_freqPos3 = g_params.m_freqPos[2];
	m_freqPos4 = g_params.m_freqPos[3];
	m_freqPos5 = g_params.m_freqPos[4];
	m_freqPos6 = g_params.m_freqPos[5];
	m_freqPos7 = g_params.m_freqPos[6];
	m_freqPos8 = g_params.m_freqPos[7];
	m_freqPos9 = g_params.m_freqPos[8];
	m_nbFreqPos = g_params.m_nbFreqPos;
	m_distFindCoreAngle = g_params.m_distFindCoreAngle;
	m_distDivCoef = TOFLT(g_params.m_distDivCoef,Q15_16);
	m_minutiaeBoost = g_params.m_minutiaeBoost;
	m_defaultSecurity = g_params.m_defaultSecurity;
	m_maxDbSearch = g_params.m_maxDbSearch;
	m_max_img_width = g_params.m_max_img_width;
	m_max_img_height = g_params.m_max_img_height;
	m_globalImgScaling = g_params.m_globalImgScaling;
	m_globalTemplateScaling = g_params.m_globalTemplateScaling;
	m_fftBlocOverlap = g_params.m_fftBlocOverlap;
	m_numOfOrientation = g_params.m_numOfOrientation;
	m_oriStepSize = g_params.m_oriStepSize;

	UpdateData(false);
}

void CParamEditorDlg::interfaceToGlobal()
{
	UpdateData(true);

	g_params.m_maxNumberOfDetectedMinutiae = m_maxNumberOfDetectedMinutiae;
	g_params.m_maxNumberOfMinutiae = m_maxNumberOfMinutiae;
	g_params.m_maxNumberOfLocalInfos = m_maxNumberOfLocalInfos;
	g_params.m_maxNumberOfCores = m_maxNumberOfCores;
	g_params.m_normalizationMean = m_normalizationMean;
	g_params.m_normalizationStdDev = m_normalizationStdDev;
	g_params.m_qualityThreshold = m_qualityThreshold;
	g_params.m_freqQualThreshold = FTOFIX32(m_freqQualThreshold,Q15_16);
	g_params.m_freqQualThresholdInc = FTOFIX32(m_freqQualThresholdInc,Q15_16);
	g_params.m_spectrumMultFactor = FTOFIX32(m_spectrumMultFactor,Q15_16);
	g_params.m_gaborWidth = FTOFIX32(m_gaborWidth,Q15_16);
	g_params.m_gaborFreqMult = FTOFIX32(m_gaborFreqMult,Q15_16);
	g_params.m_gaborFusionThreshold = FTOFIX32(m_gaborFusionThreshold,Q15_16);
	g_params.m_regionDivCoef = FTOFIX32(m_regionDivCoef,Q15_16);
	g_params.m_nbClassesSegmentation = m_nbClassesSegmentation;
	g_params.m_nbClassesRejectSegmentation = m_nbClassesRejectSegmentation;
	g_params.m_segmMedianFilterSize = m_segmMedianFilterSize;
	g_params.m_regionPerimeterCoef = m_regionPerimeterCoef;
	g_params.m_regionSurfaceCoef = m_regionSurfaceCoef;
	g_params.m_oriFusionMedianSize = m_oriFusionMedianSize;
	g_params.m_nbPtsFusionThreshold = m_nbPtsFusionThreshold;
	g_params.m_multFactorRegionFusion = FTOFIX32(m_multFactorRegionFusion,Q15_16);
	g_params.m_fusionErodeSize = m_fusionErodeSize;
	g_params.m_finalFusionMedianSize = m_finalFusionMedianSize;
	g_params.m_fusionIntensityMultFactor = FTOFIX32(m_fusionIntensityMultFactor,Q15_16);
	g_params.m_binaryMedianSize = m_binaryMedianSize;
	g_params.m_minimumCurvatureThreshold = m_minimumCurvatureThreshold;
	g_params.m_localInfosBlocSize = m_localInfosBlocSize;
	g_params.m_minutiaeNeiborhoodSize = m_minutiaeNeiborhoodSize;
	g_params.m_branchMinSize = m_branchMinSize;
	g_params.m_maxReconnectSize = m_maxReconnectSize;
	g_params.m_minReconnectionAngle = m_minReconnectionAngle;
	g_params.m_maxSupprAngle = m_maxSupprAngle;
	g_params.m_poincareSize = m_poincareSize;
	g_params.m_maxRegistrationAngle = m_maxRegistrationAngle;
	g_params.m_fisrtPassAngleStep = m_firstPassAngleStep;
	g_params.m_registerTranslationTolerance = m_registerTranslationTolerance;
	g_params.m_translation = m_translation;
	g_params.m_translationShift = m_translationShift;
	g_params.m_maxTranslationWidthShift1 = m_maxTranslationWidthShift1;
	g_params.m_maxTranslationWidthShift2 = m_maxTranslationWidthShift2;
	g_params.m_maxTranslationWidth1 = m_maxTranslationWidth1;
	g_params.m_maxTranslationWidth2 = m_maxTranslationWidth2;
	g_params.m_accuFill = m_accuFill;
	g_params.m_translationMaxThreshold = FTOFIX32(m_translationMaxThreshold,Q15_16);
	g_params.m_angleTolerance = m_angleTolerance;
	g_params.m_translationTolerance = m_translationTolerance;
	g_params.m_splineStiffness = FTOFIX32(m_splineStiffness,Q15_16);
	g_params.m_minNumberOfMinutiae = m_minNumberOfMinutiae;
	g_params.m_oriMatchNormalize = FTOFIX32(m_oriMatchNormalize,Q15_16);
	g_params.m_maxScore = m_maxScore;
	g_params.m_scoreNormalize = FTOFIX32(m_scoreNormalize,Q15_16);
	g_params.m_powFftFlag = m_powFftFlag;
	g_params.m_maxDeformation = m_maxDeformation;
	g_params.m_freqPos[0] = m_freqPos1;
	g_params.m_freqPos[9] = m_freqPos10;
	g_params.m_freqPos[1] = m_freqPos2;
	g_params.m_freqPos[2] = m_freqPos3;
	g_params.m_freqPos[3] = m_freqPos4;
	g_params.m_freqPos[4] = m_freqPos5;
	g_params.m_freqPos[5] = m_freqPos6;
	g_params.m_freqPos[6] = m_freqPos7;
	g_params.m_freqPos[7] = m_freqPos8;
	g_params.m_freqPos[8] = m_freqPos9;
	g_params.m_nbFreqPos = m_nbFreqPos;
	g_params.m_distFindCoreAngle = m_distFindCoreAngle;
	g_params.m_distDivCoef = FTOFIX32(m_distDivCoef,Q15_16);
	g_params.m_minutiaeBoost = m_minutiaeBoost;
	g_params.m_defaultSecurity = m_defaultSecurity;
	g_params.m_maxDbSearch = m_maxDbSearch;
	g_params.m_max_img_width = m_max_img_width;
	g_params.m_max_img_height = m_max_img_height;
	g_params.m_globalImgScaling = m_globalImgScaling;
	g_params.m_globalTemplateScaling = m_globalTemplateScaling;
	g_params.m_oriStepSize = m_oriStepSize;
}

BOOL CParamEditorDlg::DestroyWindow() 
{
	dpUnInit();
	
	return CDialog::DestroyWindow();
}
