/*
Company :		ZEFYR Technologies
File :			quicksort.h
Author :		Matthieu Perreira Da Silva 
Fisrt release :	09/05/2003

Description : sorting algorithms

Features : a fast sorting algorithm 
    
Functions : 

	sortUINT32 : main sorting routine
	splitUINT32 : split the array int who arrays, one with values > pivot the othe with values < pivot

Function prototypes :

	void sortUINT32( unsigned int *p_tab, unsigned int *p_index, int p_borneInf, int p_borneSup );
	int splitUINT32( unsigned int *p_tab, unsigned int *p_index,  int p_taille );

Necessary package : 

	none

Comments : none

*/

#include <stdio.h>
#include <stdlib.h>
#include <quicksort.h>

#include "errorCodes.h"
#include "staticParameters.h"

//	Splits an array into two sub-arrays
//	return the splitting position
INT32 splitUINT32( UINT32 *p_tab, UINT32 *p_index,  INT32 p_taille )
{
	UINT32 pivot = p_tab[ p_taille/2 ];
	INT32 indPivot = p_taille/2;
	INT32 i, j, tmp2;
	UINT32 tmp;
	
	i=0;
	j=p_taille-1;
	
	while( i<j )
	{	
		while( p_tab[i] <= pivot && i < indPivot) i++;
		while( p_tab[j] >= pivot && j > indPivot && i<j) j--;

		if( i == indPivot ) indPivot=j;
		else if( j == indPivot ) indPivot=i;
		tmp = p_tab[i];
		p_tab[i] = p_tab[j];
		p_tab[j] = tmp;
		tmp2 = p_index[i];
		p_index[i] = p_index[j];
		p_index[j] = tmp2;
	}
	return indPivot;
}

// Sorts an array
void sortUINT32( UINT32 *p_tab, UINT32 *p_index, INT32 p_borneInf, INT32 p_borneSup )
{
	INT32 i;
	
	i=splitUINT32( p_tab+p_borneInf, p_index+p_borneInf, p_borneSup-p_borneInf+1 );

	if( p_borneSup-p_borneInf>1 )
	{
		sortUINT32( p_tab, p_index, p_borneInf, p_borneInf+i);
		sortUINT32( p_tab, p_index, p_borneInf+i, p_borneSup );
	}
}
